#include <allegro5/allegro.h>
#include <allegro5/allegro_native_dialog.h>
#include <allegro5/allegro_ttf.h>
#include <allegro5/allegro_font.h>
#include <allegro5/allegro_ttf.h>
#include <allegro5/allegro_primitives.h>
#include <iostream>
#include<stdio.h>
#include<ctime>
 int sw=1000;
 int sh=800;// variables for screen width and screen height respectively
int cube[6][3][3],scube[6][3][3];
void mainwindow();// creates the first display screen
void gamewindow();// creates the game window
void creditswindow();// for credits
void scramblecube();// for scrambling the cube
void turnLU();
void turnRU();
void turnTR();
void turnBR();
void turnFC();
void turnBC();

/* We are defining the cube to be an array of 6x3x3 as we have 6 faces
 each with a 3x3 matrix. Each element of an array represents a tile  */
// Following are the functions making use of the above six functions to make opposite move.
//Considering blue face kept in front with white face at the top as per a standard cube, moves are named likewise
void turnLD();
void turnRD();
void turnTL();
void turnBL();
void turnFA();
void turnBA();



void turnLU()
// This function moves left side up

  {int r,c;
     for(r=0; r<3;r++)
        {c=cube[0][r][0];
         cube[0][r][0]=cube[3][r][0];
         cube[3][r][0]=cube[2][r][0];
         cube[2][r][0]=cube[1][r][0];
         cube[1][r][0]=c;
         }
     c=cube[5][2][0];
     cube[5][2][0]=cube[5][0][0];
     cube[5][0][0]=cube[5][0][2];
     cube[5][0][2]=cube[5][2][2];
     cube[5][2][2]=c;
     c=cube[5][1][0];
     cube[5][1][0]=cube[5][0][1];
     cube[5][0][1]=cube[5][1][2];
     cube[5][1][2]=cube[5][2][1];
     cube[5][2][1]=c;

}


void turnRU()
// This function moves right side up
  {int r,c;
     for(r=0; r<3;r++)
        {c=cube[0][r][2];
         cube[0][r][2]=cube[3][r][2];
         cube[3][r][2]=cube[2][r][2];
         cube[2][r][2]=cube[1][r][2];
         cube[1][r][2]=c;
         }
     c=cube[4][2][0];
     cube[4][2][0]=cube[4][2][2];
     cube[4][2][2]=cube[4][0][2];
     cube[4][0][2]=cube[4][0][0];
     cube[4][0][0]=c;
     c=cube[4][1][0];
     cube[4][1][0]=cube[4][2][1];
     cube[4][2][1]=cube[4][1][2];
     cube[4][1][2]=cube[4][0][1];
     cube[4][0][1]=c;

}


void turnTR()
// This is for moving top face right
  {int r,c;
    for(r=0;r<3;r++)
     {c=cube[0][0][r];
     cube[0][0][r]=cube[5][2-r][0];
     cube[5][2-r][0]=cube[2][2][2-r];
     cube[2][2][2-r]=cube[4][2-r][0];
     cube[4][2-r][0]=c;
     }
  c=cube[1][0][0];
  cube[1][0][0]=cube[1][0][2];
  cube[1][0][2]=cube[1][2][2];
  cube[1][2][2]=cube[1][2][0];
  cube[1][2][0]=c;
  c=cube[1][0][1];
  cube[1][0][1]=cube[1][1][2];
  cube[1][1][2]=cube[1][2][1];
  cube[1][2][1]=cube[1][1][0];
  cube[1][1][0]=c;

  }


void turnBR()
// This is for moving bottom face right
  {int r,c;
   for(r=0;r<3;r++)
   {c=cube[0][2][r];
    cube[0][2][r]=cube[5][2-r][2];
    cube[5][2-r][2]=cube[2][0][2-r];
    cube[2][0][2-r]=cube[4][2-r][2];
    cube[4][2-r][2]=c;
   }
  c=cube[3][0][0];
  cube[3][0][0]=cube[3][2][0];
  cube[3][2][0]=cube[3][2][2];
  cube[3][2][2]=cube[3][0][2];
  cube[3][0][2]=c;
  c=cube[3][0][1];
  cube[3][0][1]=cube[3][1][0];
  cube[3][1][0]=cube[3][2][1];
  cube[3][2][1]=cube[3][1][2];
  cube[3][1][2]=c;

 }


void turnFC(){
// This is for moving front face clockwise.
  int r,c;
   for(r=0;r<3;r++)
   {c=cube[1][2][r];
    cube[1][2][r]=cube[5][0][2-r];
    cube[5][0][2-r]=cube[3][0][2-r];
    cube[3][0][2-r]=cube[4][2][r];
    cube[4][2][r]=c;
   }
  c=cube[0][0][0];
  cube[0][0][0]=cube[0][2][0];
  cube[0][2][0]=cube[0][2][2];
  cube[0][2][2]=cube[0][0][2];
  cube[0][0][2]=c;
  c=cube[0][0][1];
  cube[0][0][1]=cube[0][1][0];
  cube[0][1][0]=cube[0][2][1];
  cube[0][2][1]=cube[0][1][2];
  cube[0][1][2]=c;


 }


void turnBC()
// This is for moving back anticlockwise.
  {int r,c;
   for(r=0;r<3;r++)
   {c=cube[1][0][r];
    cube[1][0][r]=cube[5][2][2-r];
    cube[5][2][2-r]=cube[3][2][2-r];
    cube[3][2][2-r]=cube[4][0][r];
    cube[4][0][r]=c;
   }
  c=cube[2][2][2];
  cube[2][2][2]=cube[2][2][0];
  cube[2][2][0]=cube[2][0][0];
  cube[2][0][0]=cube[2][0][2];
  cube[2][0][2]=c;
  c=cube[2][2][1];
  cube[2][2][1]=cube[2][1][0];
  cube[2][1][0]=cube[2][0][1];
  cube[2][0][1]=cube[2][1][2];
  cube[2][1][2]=c;

    }




/* Above were the six functions making a unidirectional move once. If the same move is repeated thrice gives move in the opposite directon.
Hence we do not need to write more functions in a similar way as above to deal with the opposite move.*/


void turnLD()
   {turnLU();
    turnLU();
    turnLU();
   }

void turnRD()
   {turnRU();
    turnRU();
    turnRU();
   }

void turnTL()
   {turnTR();
    turnTR();
    turnTR();
   }

void turnBL()
   {turnBR();
    turnBR();
    turnBR();
   }

void turnFA()
   {turnFC();
    turnFC();
    turnFC();
   }

void turnBA()
   {turnBC();
    turnBC();
    turnBC();
   }


int main()
{
    scramblecube();
    mainwindow();


    return 0;

}
void mainwindow()
{
    // variables for screen width and screen height respectively


    ALLEGRO_DISPLAY *display;//display created
    if(!al_init())
        al_show_native_message_box(NULL, NULL, NULL, "Could not initialize Allegro 5", NULL,NULL);// If not created, point out
    display = al_create_display(sw,sh);
    al_set_window_title(display,"RUBIKS");
    al_set_window_position(display,0,0);
    al_init_primitives_addon();//initializing addon for drawing primitive shapes
     al_install_mouse();
     al_init_font_addon();
     al_init_ttf_addon();// addon for truetype text file
    ALLEGRO_EVENT_QUEUE *event1=al_create_event_queue();// creating an event queue
    ALLEGRO_TIMER *timer=al_create_timer(1.0 / 60);
    ALLEGRO_FONT *font=al_load_font("Corbel.ttf",48,NULL);
   al_register_event_source(event1,al_get_display_event_source(display));// registering events in event queue
   al_register_event_source(event1, al_get_mouse_event_source());
   al_register_event_source(event1, al_get_timer_event_source(timer));
   // text appears on display screen
   al_draw_text(font,al_map_rgb(255,165,0),sw/2,sh/20,ALLEGRO_ALIGN_CENTRE,"RUBIKS CUBE");
   al_draw_text(al_load_font("Corbel.ttf",36,NULL),al_map_rgb(44,0,255),sw/2,sh/20*6,ALLEGRO_ALIGN_CENTRE,"NEW GAME");
   al_draw_text(al_load_font("Corbel.ttf",36,NULL),al_map_rgb(44,0,255),sw/2,sh/20*9,ALLEGRO_ALIGN_CENTRE,"CREDITS");
   al_draw_text(al_load_font("Corbel.ttf",36,NULL),al_map_rgb(44,0,255),sw/2,sh/20*12,ALLEGRO_ALIGN_CENTRE,"EXIT");
   al_flip_display();
   bool done=false;//loop control variable
   int x,y;// to get co-ordinates of mouse click
   al_start_timer(timer);
   while(!done)
   {
        ALLEGRO_EVENT events;
    al_wait_for_event(event1, &events);// to get event
     if(events.type==ALLEGRO_EVENT_DISPLAY_CLOSE)
        {done=true;}// to close if close button is clicked
     else if(events.type==ALLEGRO_EVENT_MOUSE_BUTTON_DOWN)
    {
        if(events.mouse.button&1)// get co-ordinates of mouse clicks
            {
            x=events.mouse.x;
            y=events.mouse.y;
            }
            //  to open the required window according to the click
       if(y>sh/20*3&&y<sh/20*6)
        {al_set_window_position(display,0,0);
        al_destroy_display(display);
        gamewindow();done=true;

       }
       else if(y>sh/20*7&y<sh/20*9)
        {
        al_destroy_display(display);
        creditswindow();continue;//call the credits window


       }
       else if(y>sh/20*9&&y<sh/20*15)
        {

        done=true;//exit

       }

}
   }//deallocate memory
   al_destroy_display(display);
    al_destroy_font(font);
    al_destroy_timer(timer);
    al_destroy_event_queue(event1);
   return;
}
void gamewindow()
{
    int i,j,x,y,x1,y1,f,r,c;
    double time; char s[50];int sl;

    /* i and j are loop control variables.
       x,y,x1 and y1 are used for referencing x and y co-ordinates of pixels
       f,r,c are used for referencing indexes of face, row and column of the cube respectively
       time and s are used for storing time. sl for storing string length*/
    ALLEGRO_DISPLAY *display;
    if(!al_init())
        al_show_native_message_box(NULL, NULL, NULL, "Could not initialize Allegro 5", NULL,NULL);
    display = al_create_display(sw,sh);//refer to previous function. details are same
    al_set_window_title(display,"RUBIKS");
    al_set_window_position(display,0,0);
    al_init_primitives_addon();
     al_install_mouse();
     al_init_font_addon();
     al_init_ttf_addon();
     ALLEGRO_COLOR color;//color control variable
     // defining colours
     ALLEGRO_COLOR red=al_map_rgb(255,0,0);
     ALLEGRO_COLOR blue=al_map_rgb(0,0,255);
     ALLEGRO_COLOR green=al_map_rgb(0,255,0);
     ALLEGRO_COLOR white=al_map_rgb(255,255,255);
     ALLEGRO_COLOR yellow=al_map_rgb(255,255,0);
     ALLEGRO_COLOR orange=al_map_rgb(255,165,0);
    ALLEGRO_EVENT_QUEUE *event1=al_create_event_queue();//creating event queue and timer
    ALLEGRO_TIMER *timer=al_create_timer(1.0 / 60);

   al_register_event_source(event1,al_get_display_event_source(display));//registering events
   al_register_event_source(event1, al_get_mouse_event_source());
   al_register_event_source(event1, al_get_timer_event_source(timer));
   //loading text to be displayed on the screen
   al_draw_text(al_load_font("Corbel.ttf",36,NULL),al_map_rgb(44,0,255),sw/10*9,sh/10*6,ALLEGRO_ALIGN_LEFT,"BACK");
   x=sw/4*3-200;y=y1=sw/25*2;
   al_draw_text(al_load_font("Corbel.ttf",30,NULL),al_map_rgb(44,0,255),x,y,ALLEGRO_ALIGN_LEFT,"MOVE 1");
   y+=y1;
   al_draw_text(al_load_font("Corbel.ttf",30,NULL),al_map_rgb(44,0,255),x,y,ALLEGRO_ALIGN_LEFT,"MOVE 2");
   y+=y1;
   al_draw_text(al_load_font("Corbel.ttf",30,NULL),al_map_rgb(44,0,255),x,y,ALLEGRO_ALIGN_LEFT,"MOVE 3");
   y+=y1;
   al_draw_text(al_load_font("Corbel.ttf",30,NULL),al_map_rgb(44,0,255),x,y,ALLEGRO_ALIGN_LEFT,"MOVE 4");
   y+=y1;
   al_draw_text(al_load_font("Corbel.ttf",30,NULL),al_map_rgb(44,0,255),x,y,ALLEGRO_ALIGN_LEFT,"MOVE 5");
   y+=y1;
   al_draw_text(al_load_font("Corbel.ttf",30,NULL),al_map_rgb(44,0,255),x,y,ALLEGRO_ALIGN_LEFT,"MOVE 6");
   y+=y1;
   x=sw/4*3+100;y=y1=sw/25*2;
   al_draw_text(al_load_font("Corbel.ttf",30,NULL),al_map_rgb(44,0,255),x,y,ALLEGRO_ALIGN_RIGHT,"MOVE 7");
   y+=y1;
   al_draw_text(al_load_font("Corbel.ttf",30,NULL),al_map_rgb(44,0,255),x,y,ALLEGRO_ALIGN_RIGHT,"MOVE 8");
   y+=y1;
   al_draw_text(al_load_font("Corbel.ttf",30,NULL),al_map_rgb(44,0,255),x,y,ALLEGRO_ALIGN_RIGHT,"MOVE 9");
   y+=y1;
   al_draw_text(al_load_font("Corbel.ttf",30,NULL),al_map_rgb(44,0,255),x,y,ALLEGRO_ALIGN_RIGHT,"MOVE 10");
   y+=y1;
   al_draw_text(al_load_font("Corbel.ttf",30,NULL),al_map_rgb(44,0,255),x,y,ALLEGRO_ALIGN_RIGHT,"MOVE 11");
   y+=y1;
   al_draw_text(al_load_font("Corbel.ttf",30,NULL),al_map_rgb(44,0,255),x,y,ALLEGRO_ALIGN_RIGHT,"MOVE 12");


    bool done=false;//loop control variable
    int xm,ym;//to store and use co-ordinates of mouse click
    int solved;// for checking if cube is solved or not

    al_start_timer(timer);
    while(!done)
    {
        //Start generating the image of the cube. Six faces of the cube are shown in two isometric views
    x=sw/4;y=sh/4;x1=x+31.64;y1=y+20;f=5;r=0;c=0;solved=1;
    //first face
    for(i=0;i<6;i++)
    {
        for(j=0;j<3;j++)
        {
            r=j;
            switch(cube[f][r][c])
            {
            case 0:
                color=blue;break;
                case 1:
                color=white;break;
                case 2:
                color=green;break;
                case 3:
                color=yellow;break;
                case 4:
                color=orange;break;
                case 5:
                color=red;break;

            }
            al_draw_filled_triangle(x,y,x,y+40,x1,y1,color);
            y+=40;y1+=40;
        }
        if(i%2==0)
        {
            x=x+31.64;x1=x-31.64;y=y-100;y1-=100;
        }
        else
        {
            x1=x+31.64;y-=120;y1-=120;c++;
        }


    }
    // Second face
    f=3;r=0;c=0;
    for(i=0;i<6;i++)
    {
        for(j=0;j<3;j++)
        {
            r=j;
            switch(cube[f][r][c])
            {
            case 0:
                color=blue;break;
                case 1:
                color=white;break;
                case 2:
                color=green;break;
                case 3:
                color=yellow;break;
                case 4:
                color=orange;break;
                case 5:
                color=red;break;

            }
            al_draw_filled_triangle(x,y,x,y+40,x1,y1,color);
            y+=40;y1+=40;
        }
        if(i%2==0)
        {
            x=x+31.64;x1=x-31.64;y=y-140;y1-=140;
        }
        else
        {
            x1=x+31.64;y-=120;y1-=120;c++;
        }


    }
    //third face
    x=x-3*31.64-5+10;y=y+50+10;x1=x-31.64;y1=y-20;
    f=0;r=0;c=0;

    for(i=0;i<3;i++)
    {
        for(j=0;j<3-i;j++)
        {
            if(i==0)
            {
             c=j;r=2-j;
             switch(cube[f][r][c])
            {
            case 0:
                color=blue;break;
                case 1:
                color=white;break;
                case 2:
                color=green;break;
                case 3:
                color=yellow;break;
                case 4:
                color=orange;break;
                case 5:
                color=red;break;

            }
             al_draw_filled_triangle(x,y,x,y-40,x1,y1,color);

            }
            else
            {
             if(i==1)
             {
                 r=i-j;c=j;
             }
             else if(i==2)
             {
                 r=0;c=0;
             }
             switch(cube[f][r][c])
            {
            case 0:
                color=blue;break;
                case 1:
                color=white;break;
                case 2:
                color=green;break;
                case 3:
                color=yellow;break;
                case 4:
                color=orange;break;
                case 5:
                color=red;break;

            }
             al_draw_filled_triangle(x,y,x,y-40,x1,y1,color);
             al_draw_filled_triangle(x,y,x,y-40,x1+2*31.64,y1,color);
            }
            y-=40;y1-=40;
        }
        x=x1;x1=x-31.64;y=y+40*(3-i)-20;y1=y1+40*(3-i)-20;
    }
    x=346;y=260;x1=x+31.64;y1=y-20;r=0;c=0;
    for(i=0;i<3;i++)
    {
        for(j=0;j<3-i;j++)
        {
            if(i==0)
            {
             r=2-j;c=j;
             switch(cube[f][r][c])
            {
            case 0:
                color=blue;break;
                case 1:
                color=white;break;
                case 2:
                color=green;break;
                case 3:
                color=yellow;break;
                case 4:
                color=orange;break;
                case 5:
                color=red;break;

            }
             al_draw_filled_triangle(x,y,x,y-40,x1,y1,color);

            }
            else
            {
             if(i==1)
             {
                 r=i-j+1;c=j+1;
             }
             else if(i==2)
             {
                 r=2;c=2;
             }
             switch(cube[f][r][c])
            {
            case 0:
                color=blue;break;
                case 1:
                color=white;break;
                case 2:
                color=green;break;
                case 3:
                color=yellow;break;
                case 4:
                color=orange;break;
                case 5:
                color=red;break;

            }
             al_draw_filled_triangle(x,y,x,y-40,x1,y1,color);
             al_draw_filled_triangle(x,y,x,y-40,x1-2*31.64,y1,color);
            }
            y-=40;y1-=40;
        }
        x=x1;x1=x+31.64;y=y+40*(3-i)-20;y1=y1+40*(3-i)-20;
    }
    // fourth face
    x=sw/4,y=sh/4*3,x1=x+31.64,y1=y+20;f=1;r=0;c=0;
    for(i=0;i<6;i++)
    {
        for(j=0;j<3;j++)
        {
            r=j;
            switch(cube[f][r][c])
            {
            case 0:
                color=blue;break;
                case 1:
                color=white;break;
                case 2:
                color=green;break;
                case 3:
                color=yellow;break;
                case 4:
                color=orange;break;
                case 5:
                color=red;break;

            }
            al_draw_filled_triangle(x,y,x,y+40,x1,y1,color);
            y+=40;y1+=40;
        }
        if(i%2==0)
        {
            x=x+31.64;x1=x-31.64;y=y-100;y1-=100;
        }
        else
        {
            x1=x+31.64;y-=120;y1-=120;c++;
        }


    }
    // fifth face
    f=4;r=0;c=0;
    for(i=0;i<6;i++)
    {
        for(j=0;j<3;j++)
        {
            r=j;
            switch(cube[f][r][c])
            {
            case 0:
                color=blue;break;
                case 1:
                color=white;break;
                case 2:
                color=green;break;
                case 3:
                color=yellow;break;
                case 4:
                color=orange;break;
                case 5:
                color=red;break;

            }
            al_draw_filled_triangle(x,y,x,y+40,x1,y1,color);
            y+=40;y1+=40;
        }
        if(i%2==0)
        {
            x=x+31.64;x1=x-31.64;y=y-140;y1-=140;
        }
        else
        {
            x1=x+31.64;y-=120;y1-=120;c++;
        }


    }
    // sixth face
    x=x-3*31.64-5+10;y=y+50+10;x1=x-31.64;y1=y-20;f=2;c=0;r=0;


    for(i=0;i<3;i++)
    {
        for(j=0;j<3-i;j++)
        {
            if(i==0)
            {
             r=2-j;c=2-j;
             switch(cube[f][r][c])
            {
            case 0:
                color=blue;break;
                case 1:
                color=white;break;
                case 2:
                color=green;break;
                case 3:
                color=yellow;break;
                case 4:
                color=orange;break;
                case 5:
                color=red;break;

            }
             al_draw_filled_triangle(x,y,x,y-40,x1,y1,color);
            }
            else
            {
             if(i==1)
             {
                 r=2-j;c=1-j;

             }
             else if(i==2)
             {
                 r=2;c=0;
             }
             switch(cube[f][r][c])
            {
            case 0:
                color=blue;break;
                case 1:
                color=white;break;
                case 2:
                color=green;break;
                case 3:
                color=yellow;break;
                case 4:
                color=orange;break;
                case 5:
                color=red;break;

            }
             al_draw_filled_triangle(x,y,x,y-40,x1,y1,color);
             al_draw_filled_triangle(x,y,x,y-40,x1+2*31.64,y1,color);
            }
            y-=40;y1-=40;
        }
        x=x1;x1=x-31.64;y=y+40*(3-i)-20;y1=y1+40*(3-i)-20;
    }
    x=346;y=660;x1=x+31.64;y1=y-20;
    for(i=0;i<3;i++)
    {
        for(j=0;j<3-i;j++)
        {
            if(i==0)
            {
             r=2-j;c=2-j;
             switch(cube[f][r][c])
            {
            case 0:
                color=blue;break;
                case 1:
                color=white;break;
                case 2:
                color=green;break;
                case 3:
                color=yellow;break;
                case 4:
                color=orange;break;
                case 5:
                color=red;break;

            }
             al_draw_filled_triangle(x,y,x,y-40,x1,y1,color);
            }
            else
            {
             if(i==1)
             {
                 r=1-j;c=2-j;
             }
             else if(i==2)
             {
                 r=0;c=2;
             }

             switch(cube[f][r][c])
            {
            case 0:
                color=blue;break;
                case 1:
                color=white;break;
                case 2:
                color=green;break;
                case 3:
                color=yellow;break;
                case 4:
                color=orange;break;
                case 5:
                color=red;break;

            }
             al_draw_filled_triangle(x,y,x,y-40,x1,y1,color);
             al_draw_filled_triangle(x,y,x,y-40,x1-2*31.64,y1,color);
            }
            y-=40;y1-=40;
        }
        x=x1;x1=x+31.64;y=y+40*(3-i)-20;y1=y1+40*(3-i)-20;
    }
    // check if cube is solved
    for(f=0;f<6;f++)
    {
        for(r=0;r<3;r++)
            for(c=0;c<3;c++)
            if(cube[f][r][c]!=scube[f][r][c])
            {
                solved=0;
            }
    }
    if(solved==1)
        {done=true;time=al_get_timer_count(timer);}


     // Getting mouse clicks and executing accordingly
     ALLEGRO_EVENT events;
    al_wait_for_event(event1, &events);
     if(events.type==ALLEGRO_EVENT_DISPLAY_CLOSE)
        done=true;
     else if(events.type==ALLEGRO_EVENT_MOUSE_BUTTON_DOWN)
    {
        if(events.mouse.button&1)// get xm,ym
            {
            xm=events.mouse.x;
            ym=events.mouse.y;
            }
       if(ym>sh/10*3&&ym<sh/10*6&&xm>sw/10*9)
        {
        al_destroy_display(display);
        mainwindow();return;

       }
       if(xm>537&&xm<666&&ym<94&&ym>64)
        turnLU();
       if(xm>537&&xm<666&&ym<158&&ym>128)
        turnRU();
        if(xm>537&&xm<666&&ym<212+10&&ym>192+10)
        turnTR();
        if(xm>537&&xm<666&&ym<286+30&&ym>256+30)
        turnBR();
        if(xm>537&&xm<666&&ym<350+30&&ym>320+30)
        turnFC();
        if(xm>537&&xm<666&&ym<398+50&&ym>368+50)
        turnBC();
        if(xm>741&&xm<870&&ym<94&&ym>64)
        turnLD();
       if(xm>741&&xm<870&&ym<158&&ym>128)
        turnRD();
        if(xm>741&&xm<870&&ym<212+10&&ym>192+10)
        turnTL();
        if(xm>741&&xm<870&&ym<286+30&&ym>256+30)
        turnBL();
        if(xm>741&&xm<870&&ym<350+30&&ym>320+30)
        turnFA();
        if(xm>741&&xm<870&&ym<398+50&&ym>368+50)
        turnBA();



    }

        al_flip_display();}
        // message to show if the cube is solved

         sl=sprintf(s,"It took %d seconds",time);

        if(solved==1)
            {al_draw_text(al_load_font("Corbel.ttf",30,NULL),al_map_rgb(44,0,255),sw/4,sh/2+50,ALLEGRO_ALIGN_CENTER,"CONGRATULATIONS FOR SOLVING :)");
            al_draw_text(al_load_font("Corbel.ttf",30,NULL),al_map_rgb(44,0,255),sw/4,sh/2+90,ALLEGRO_ALIGN_CENTER,s);
             al_flip_display();
             al_rest(2.0);
             }
   // de-allocating memory
   al_destroy_display(display);
   al_destroy_timer(timer);
   al_destroy_event_queue(event1);
   return;

}
void creditswindow()
{
 int xm,ym;bool done=false;// Same as creating displays in the previous two functions
    ALLEGRO_DISPLAY *display;
    if(!al_init())
        al_show_native_message_box(NULL, NULL, NULL, "Could not initialize Allegro 5", NULL,NULL);
    display = al_create_display(sw,sh);
    al_set_window_title(display,"RUBIKS");
    al_set_window_position(display,0,0);
    al_install_mouse();
     al_init_font_addon();
     al_init_ttf_addon();
    ALLEGRO_EVENT_QUEUE *event1=al_create_event_queue();
    ALLEGRO_TIMER *timer=al_create_timer(1.0 / 60);
    ALLEGRO_FONT *font=al_load_font("Corbel.ttf",36,NULL);
    al_register_event_source(event1,al_get_display_event_source(display));
    al_register_event_source(event1, al_get_mouse_event_source());
   al_register_event_source(event1, al_get_timer_event_source(timer));
   // loading text to be displayed on the screen
   al_draw_text(font,al_map_rgb(44,0,255),sw/2,sh/10*8,ALLEGRO_ALIGN_CENTRE,"BACK");
   al_draw_text(font,al_map_rgb(44,0,255),sw/2,sh/10*2,ALLEGRO_ALIGN_CENTRE,"VISHVESH KORANNE(L), DHEERAJ K VERMA, ASHMAK MOON");
   al_draw_text(font,al_map_rgb(44,0,255),sw/2,sh/10*4,ALLEGRO_ALIGN_CENTRE,"THANKS TO TA MANISH GOREGAONKAR AND FACULTY");
   al_draw_text(font,al_map_rgb(44,0,255),sw/2,sh/10*6,ALLEGRO_ALIGN_CENTRE,"SPECIAL THANKS TO SUSHIL VERMA, KUNJ PATEL ");
   al_flip_display();
   al_start_timer(timer);
   while(!done)
   {
        ALLEGRO_EVENT events;
    al_wait_for_event(event1, &events);
     if(events.type==ALLEGRO_EVENT_DISPLAY_CLOSE)
        done=true;
     else if(events.type==ALLEGRO_EVENT_MOUSE_BUTTON_DOWN)
    {
        if(events.mouse.button&1)
            {
            xm=events.mouse.x;
            ym=events.mouse.y;
            }
       if(ym>sh/10*6&&ym<sh/10*8)
        {al_set_window_position(display,0,0);
        al_destroy_display(display);
        mainwindow();done=true;
        }
}} // de-allocate memory
   al_destroy_display(display);
   al_destroy_font(font);
   al_destroy_timer(timer);
   al_destroy_event_queue(event1);
   return;}
void scramblecube()
{
    int f,r,c,i,m;
    /* f,r,c are used for referencing to the indexes of the face, row and column of a cube respectively
       i is loop control variable
       m is used to store the random number between 0-11 and as switch case control variable*/
    // initializing cube to undisturbed state
    for(f=0;f<6;f++)
    {
        for(r=0;r<3;r++)
            for(c=0;c<3;c++)
            {cube[f][r][c]=f;scube[f][r][c]=f;}// also initializing a solved cube
    }

    // Randomly make 30 moves to scramble the cube
    srand(time(0));
    for(i=0;i<30;i++)
    {
        m=rand()%12;
        switch(m)
        {
        case 0:
              turnLU();break;
              case 1:
              turnRU();break;
              case 2:
              turnTR();break;
              case 3:
              turnBR();break;
              case 4:
              turnFC();break;
              case 5:
              turnBC();break;
              case 6:
              turnLD();break;
              case 7:
              turnRD();break;
              case 8:
              turnTL();break;
              case 9:
              turnBL();break;
              case 10:
              turnFA();break;
              case 11:
              turnBA();break;

        }
    }


    return;
}

/*
srand(time(0));
    for(i=0;i<30;i++)
    {
        m=rand()%12;
        switch(m)
        {
        case 0:
              turnLU();break;
              case 1:
              turnRU();break;
              case 2:
              turnTR();break;
              case 3:
              turnBR();break;
              case 4:
              turnFC();break;
              case 5:
              turnBC();break;
              case 6:
              turnLD();break;
              case 7:
              turnRD();break;
              case 8:
              turnTL();break;
              case 9:
              turnBL();break;
              case 10:
              turnFA();break;
              case 11:
              turnBA();break;

        }
    }
*/
/*include<iostream>
using namespace std;
/* This is CS101 project for the academic year 2014-2015. Presenting RUBIX CUBE AUTO SOLVER.
Our group is 9 from slot 6. Team members are: Ashmak Moon (140100038), Dheeraj Kumar Verma(1401000__)
                                            and Vishvesh Koranne (Group Leader; 140100033).*/


/* I am gonna introduce some very basic needed functions to solve a what we call a Rubix Cube.
We have go a 3x3 Rubix Cube to solve. We need 6 basic functions to get it solved.
Each of the function corresponds to a basic move.
Moving the left side of the cube in clockwise direction or simply saying the move to be left up as seen by the user.
Similarly, the other moves are right up, top right, bottom right, front colckwise and back clockwise.
Now given are the functions corresponding to the moves given above respevtively.*/

/*void turnLU(int cube[6][3][3]);
void turnRU(int cube[6][3][3]);
void turnTR(int cube[6][3][3]);
void turnBR(int cube[6][3][3]);
void turnFC(int cube[6][3][3]);
void turnBC(int cube[6][3][3]);

/* We are defining each face of the cube to be an array of 3X3 and the whole of the cube to an array of 6x3x3 as we have 6 faces
and each with a 3x3 matrix. Each element is inputted by the user and what all the function doing is to make changes in the content of the
the array according to the move.*/

// Following are the functions making use of the above six functions to make opposite directional move.
/*void turnLD(int cube[6][3][3]);
void turnRD(int cube[6][3][3]);
void turnTL(int cube[6][3][3]);
void turnBL(int cube[6][3][3]);
void turnFA(int cube[6][3][3]);
void turnBA(int cube[6][3][3]);



void turnLU(int cube[6][3][3])
// This function moves left side up. i.e., left face clockwise.

  {int temp,r;
     for(r=0; r<3;r++)
        {temp=cube[0][r][2];
         cube[1][r][2]=cube[2][r][2];
         cube[2][r][2]=cube[3][r][2];
         cube[3][r][2]=cube[0][r][2];
         cube[1][r][2]=temp;
         }
     c=cube[4][2][0];
     cube[4][2][0]=cube[4][2][2];
     cube[4][2][2]=cube[4][0][2];
     cube[4][0][2]=cube[4][0][0];
     cube[4][0][0]=c;
     c=cube[4][1][0];
     cube[4][1][0]=cube[4][2][1];
     cube[4][2][1]=cube[4][1][2];
     cube[4][1][2]=cube[4][0][1];
     cube[4][0][1]=c;
     c=cube[4][0][0];
     cube[4][0][0]=cube[4][2][0];
     cube[4][2][0]=cube[4][2][2];
     cube[4][2][2]=cube[4][0][2];
     cube[4][0][2]=c;
}


void turnRU(int cube[6][3][3])
// This function moves right side up. i.e., right face anticloockwise.
  {int temp,r;
     for(r=0; r<3;r++)
        {temp=cube[0][r][0];
         cube[1][r][0]=cube[2][r][0];
         cube[2][r][0]=cube[3][r][0];
         cube[3][r][0]=cube[0][r][0];
         cube[1][r][0]=temp;
         }
     c=cube[5][2][0];
     cube[5][2][0]=cube[5][2][2];
     cube[5][2][2]=cube[5][0][2];
     cube[5][0][2]=cube[5][0][0];
     cube[5][0][0]=c;
     c=cube[5][1][0];
     cube[5][1][0]=cube[5][2][1];
     cube[5][2][1]=cube[5][1][2];
     cube[5][1][2]=cube[5][0][1];
     cube[5][0][1]=c;
     c=cube[5][0][0];
     cube[5][0][0]=cube[5][2][0];
     cube[5][2][0]=cube[5][2][2];
     cube[5][2][2]=cube[5][0][2];
     cube[5][0][2]=c;
}


void turnTR(int cube[6][3][3])
// This is for moving top face anticlockwise.
  {int temp,r,c;
    for(r=0;r,3;r++)
     {temp=cube[0][0][r];
     cube[0][0][r]=cube[5][2-r][0];
     cube[5][2-r][0]=cube[2][2][2-r];
     cube[2][2][2-r]=cube[4][2-r][0];
     cube[4][2-r][0]=temp;
     }
  c=cube[1][0][0];
  cube[1][0][0]=cube[1][2][0];
  cube[1][2][0]=cube[1][2][2];
  cube[1][2][2]=cube[1][0][2];
  cube[1][0][2]=c;
  c=cube[1][0][1];
  cube[1][0][1]=cube[1][1][0];
  cube[1][1][0]=cube[1][2][1];
  cube[1][2][1]=cube[1][1][2];
  cube[1][1][2]=c;
  c=cube[1][0][2];
  cube[1][0][2]=cube[1][0][0];
  cube[1][0][0]=cube[1][2][0];
  cube[1][2][0]=cube[1][2][2];
  cube[1][2][2]=c;
  }


void turnBR(int cube[6][3][3])
// This is for moving bottom face anticlockwise.
  {int temp,r,c;
   for(r=0;r,3;r++)
   {temp=cube[0][0][r];
    cube[0][0][r]=cube[5][2-r][2];
    cube[5][2-r][2]=cube[2][0][2-r];
    cube[2][0][2-r]=cube[4][2-r][2];
    cube[4][2-r][2]=temp;
   }
  c=cube[3][0][0];
  cube[3][0][0]=cube[3][2][0];
  cube[3][2][0]=cube[3][2][2];
  cube[3][2][2]=cube[3][0][2];
  cube[3][0][2]=c;
  c=cube[3][0][1];
  cube[3][0][1]=cube[3][1][0];
  cube[3][1][0]=cube[3][2][1];
  cube[3][2][1]=cube[3][1][2];
  cube[3][1][2]=c;
  c=cube[3][0][2];
  cube[3][0][2]=cube[3][0][0];
  cube[3][0][0]=cube[3][2][0];
  cube[3][2][0]=cube[3][2][2];
  cube[3][2][2]=c;
 }


void turnFC(int cube[6][3][3])
// This is for moving bottom face clockwise.
  {int temp,r,c;
   for(r=0;r<3;r++)
   {temp=cube[0][0][r];
    cube[0][0][r]=cube[5][2-r][2];
    cube[5][2-r][2]=cube[2][0][2-r];
    cube[2][0][2-r]=cube[4][2-r][2];
    cube[4][2-r][2]=temp;
   }
  c=cube[0][0][0];
  cube[0][0][0]=cube[0][2][0];
  cube[0][2][0]=cube[0][2][2];
  cube[0][2][2]=cube[0][0][2];
  cube[0][0][2]=c;
  c=cube[0][0][1];
  cube[0][0][1]=cube[0][1][0];
  cube[0][1][0]=cube[0][2][1];
  cube[0][2][1]=cube[0][1][2];
  cube[0][1][2]=c;
  c=cube[0][0][2];
  cube[0][0][2]=cube[0][0][0];
  cube[0][0][0]=cube[0][2][0];
  cube[0][2][0]=cube[0][2][2];
  cube[0][2][2]=c;
    }
  }


void turnBC(int cube[6][3][3])
// This is for moving back face anticlockwise.
  {int temp,r,c;
   for(r=0;r<3;r++)
   {temp=cube[1][0][r];
    cube[0][0][r]=cube[5][2][2-r];
    cube[5][2][2-r]=cube[3][2][2-r];
    cube[3][2][2-r]=cube[4][0][r];
    cube[4][0][r]=temp;
   }
  c=cube[2][2][2];
  cube[2][2][2]=cube[2][2][0];
  cube[2][2][0]=cube[2][0][0];
  cube[2][0][0]=cube[2][0][2];
  cube[2][0][2]=c;
  c=cube[2][2][1];
  cube[2][2][1]=cube[2][1][0];
  cube[2][1][0]=cube[2][0][1];
  cube[2][0][1]=cube[2][1][2];
  cube[2][1][2]=c;
  c=cube[2][2][0];
  cube[2][2][0]=cube[2][0][0];
  cube[0][0][0]=cube[2][0][2];
  cube[2][0][2]=cube[2][2][2];
  cube[2][2][2]=c;
    }

}


/* Above were the six functions making a unidirectional move once. If the same move is repeated thrice gives move in the opposite directon.
Hence we do not need to write more functions in a similar way as above to deal with the opposite sence of move.*/


/*void turnLD(int cube[6][3][3])
   {turnLU(cube[6][3][3]);
    turnLU(cube[6][3][3]);
    turnLU(cube[6][3][3]);
   }

void turnRD(int cube[6][3][3])
   {turnRU(cube[6][3][3]);
    turnRU(cube[6][3][3]);
    turnRU(cube[6][3][3]);
   }

void turnTL(int cube[6][3][3])
   {turnTR(cube[6][3][3]);
    turnTR(cube[6][3][3]);
    turnTR(cube[6][3][3]);
   }

void turnBL(int cube[6][3][3])
   {turnBR(cube[6][3][3]);
    turnBR(cube[6][3][3]);
    turnBR(cube[6][3][3]);
   }

void turnFA(int cube[6][3][3])
   {turnFC(cube[6][3][3]);
    turnFC(cube[6][3][3]);
    turnFC(cube[6][3][3]);
   }

void turnBA(int cube[6][3][3])
   {turnBC(cube[6][3][3]);
    turnBC(cube[6][3][3]);
    turnBC(cube[6][3][3]);
   }


main()
     {int a,b,c,d,e,f,int moves[1000], counter=0;
     bool correct= false;
      a=cube[1][1][1];
      b=cube[0][1][1];
      c=cube[3][1][1];
      d=cube[4][1][1];
      e=cube[2][1][1];
      f=cube[5][1][1];

      while (!correct)
       {
           if(

       }
      bool (correct=false);
      while(!correct);
      {
          if ((cube[0][0][1]==b)&&(cube[1][0][1]==a))
          correct = true;

          else{
         else if((cube[0][1][2]==b)&&(cube[1][2][1]==a))
          {
              turnFA(cube[6][3][3]);move[counter]=10;counter++;
          }
          correct = true;
          else if((cube[0][2][1]==b)&&(cube[3][0][1]==a))
          {
           turnFC(cube[6][3][3]);move[counter]=4;counter++;
           turnFC(cube[6][3][3]);move[counter]=4;counter++;
          }
          correct = true;
         else if((cube[0][1][0]==b)&&(cube[5][0][1]==a)){
          turnFC(cube[6][3][3]);move[counter]=4;counter++ }
          correct = true;

          }
         else if ((cube[5][0][1]==b)&&(cube[0][1][0]==a))
          {
              turnLU(cube[6][3][3]);move[counter]=0;counter++;
              turnBC(cube[6][3][3]);move[counter]=9;counter++;

          correct = true;


         else if((cube[1][0][1]==b)&&(cube[0][0][1]==a))
          {
              turnLU(cube[6][3][3]);move[counter]=0;counter++;

              turnBC(cube[6][3][3]);move[counter]=5;counter++;

          }
          correct = true;
         else if((cube[4][2][1]==b)&&(cube[0][1][2]==a))
          {
           turnRU(cube[6][3][3]);move[counter]=1;counter++;
           turnBA(cube[6][3][3]);move[counter]=11;counter++;
          }
          correct = true;
         else if((cube[3][0][1]==b)&&(cube[0][2][1]==a)){
          turnFC(cube[6][3][3]);move[counter]=4;counter++;
          turnLU(cube[6][3][3]);move[counter]=0;counter++;
          turnBC(cube[6][3][3]);move[counter]=9;counter++; }
          correct = true;
else if((cube[1][1][0]==b)&&(cube[5][1][0]==a)){
    turnLD(cube[6][3][3]);move[counter]=6;counter++;
          turnFC(cube[6][3][3]);move[counter]=4;counter++;
}correct = true;
else if((cube[1][1][2]==b)&&(cube[4][1][0]==a)){
    turnRD(cube[6][3][3]);move[counter]=7;counter++;
          turnFA(cube[6][3][3]);move[counter]=10;counter++;
}correct = true;
else if((cube[5][1][0]==b)&&(cube[1][1][0]==a)){
    turnBC(cube[6][3][3]);move[counter]=5;counter++;

}correct = true;


else if((cube[4][1][0]==b)&&(cube[1][1][2]==a)){
    turnBA(cube[6][3][3]);move[counter]=11;counter++;

}correct = true;
else if((cube[5][1][2]==b)&&(cube[3][0][1]==a)){
    turnLU(cube[6][3][3]);move[counter]=0;counter++;
    turnFC(cube[6][3][3]);move[counter]=4;counter++;

}correct = true;
else if((cube[4][1][2]==b)&&(cube[3][1][2]==a)){
    turnLU(cube[6][3][3]);move[counter]=0;counter++;
    turnFC(cube[6][3][3]);move[counter]=4;counter++;

}correct = true;
else if((cube[3][0][1]==b)&&(cube[5][1][2]==a)){
    turnLU(cube[6][3][3]);move[counter]=0;counter++;
    turnFC(cube[6][3][3]);move[counter]=4;counter++;

}correct = true;
else if((cube[3][1][2]==b)&&(cube[4][1][2]==a)){
    turnLU(cube[6][3][3]);move[counter]=0;counter++;
    turnFC(cube[6][3][3]);move[counter]=4;counter++;

}correct = true;
else if((cube[3][2][1]==b)&&(cube[2][1][0]==a)){
    turnLU(cube[6][3][3]);move[counter]=0;counter++;
    turnFC(cube[6][3][3]);move[counter]=4;counter++;

}correct = true;
else if((cube[1][2][1]==b)&&(cube[2][2][1]==a)){
    turnLU(cube[6][3][3]);move[counter]=0;counter++;
    turnFC(cube[6][3][3]);move[counter]=4;counter++;

}correct = true;
else if((cube[5][2][1]==b)&&(cube[2][0][1]==a)){
    turnLU(cube[6][3][3]);move[counter]=0;counter++;
    turnFC(cube[6][3][3]);move[counter]=4;counter++;

}correct = true;
else if((cube[4][0][1]==b)&&(cube[2][2][1]==a)){
    turnLU(cube[6][3][3]);move[counter]=0;counter++;
    turnFC(cube[6][3][3]);move[counter]=4;counter++;

}correct = true;
else if((cube[4][1][2]==b)&&(cube[3][1][2]==a)){
    turnLU(cube[6][3][3]);move[counter]=0;counter++;
    turnFC(cube[6][3][3]);move[counter]=4;counter++;

}correct = true;
else if((cube[4][1][2]==b)&&(cube[3][1][2]==a)){
    turnLU(cube[6][3][3]);move[counter]=0;counter++;
    turnFC(cube[6][3][3]);move[counter]=4;counter++;

}correct = true;
else if((cube[4][1][2]==b)&&(cube[3][1][2]==a)){
    turnLU(cube[6][3][3]);move[counter]=0;counter++;
    turnFC(cube[6][3][3]);move[counter]=4;counter++;

}correct = true;
else if((cube[2][0][1]==b)&&(cube[3][2][1]==a)){
    turnBR(cube[6][3][3]);move[counter]=3;counter++;
    turnBR(cube[6][3][3]);move[counter]=3;counter++;
    turnFC(cube[6][3][3]);move[counter]=4;counter++;
    turnFC(cube[6][3][3]);move[counter]=4;counter++;

}correct = true;
else if((cube[4][1][2]==b)&&(cube[3][1][2]==a)){
    turnBL(cube[6][3][3]);move[counter]=9;counter++;
    turnFC(cube[6][3][3]);move[counter]=4;counter++;
    turnFC(cube[6][3][3]);move[counter]=4;counter++;

}correct = true;


else if((cube[0][2][1]==b)&&(cube[3][0][1]==a)){

    turnFC(cube[6][3][3]);move[counter]=4;counter++;
    turnFC(cube[6][3][3]);move[counter]=4;counter++;

}correct = true;
else if((cube[5][1][2]==b)&&(cube[3][1][0]==a)){
    turnBR(cube[6][3][3]);move[counter]=3;counter++;
    turnFC(cube[6][3][3]);move[counter]=4;counter++;
    turnFC(cube[6][3][3]);move[counter]=4;counter++;

}correct = true;
else if((cube[3][2][1]==b)&&(cube[2][0][1]==a)){
    turnBL(cube[6][3][3]);move[counter]=9;counter++;
    turnRU(cube[6][3][3]);move[counter]=1;counter++;
    turnFA(cube[6][3][3]);move[counter]=10;counter++;


}correct = true;

else if((cube[3][1][2]==b)&&(cube[4][1][2]==a)){
    turnBL(cube[6][3][3]);move[counter]=9;counter++;
    turnFC(cube[6][3][3]);move[counter]=4;counter++;
    turnFC(cube[6][3][3]);move[counter]=4;counter++;


}correct = true;

else if((cube[3][0][1]==b)&&(cube[0][2][1]==a)){
    turnBR(cube[6][3][3]);move[counter]=3;counter++;
    turnRU(cube[6][3][3]);move[counter]=1;counter++;
    turnFA(cube[6][3][3]);move[counter]=10;counter++;


}correct = true;

else if((cube[3][1][0]==b)&&(cube[5][1][2]==a)){
    turnLU(cube[6][3][3]);move[counter]=0;counter++;
    turnFC(cube[6][3][3]);move[counter]=4;counter++;


}correct = true;

          }

 while(!correct);
 {

 if((cube[0][1][0]==b)&&(cube[5][0][1]==f))
        correct = true;
        else{
         else if((cube[0][2][1]==b)&&(cube[3][0][1]==f))
          {
              turnBL(cube[6][3][3]);move[counter]=9;counter++;
              turnFA(cube[6][3][3]);move[counter]=10;counter++;
              turnBR(cube[6][3][3]);move[counter]=3;counter++;
              turnFC(cube[6][3][3]);move[counter]=4;counter++;
          }
          correct = true;
          else if((cube[5][1][2]==b)&&(cube[3][1][0]==f))
          {

              turnFA(cube[6][3][3]);move[counter]=10;counter++;
              turnBR(cube[6][3][3]);move[counter]=3;counter++;
              turnF
              C(cube[6][3][3]);move[counter]=4;counter++;
          }
          correct = true;
          else if((cube[4][1][2]==b)&&(cube[3][1][2]==f))
          {

              turnFA(cube[6][3][3]);move[counter]=10;counter++;
              turnBl(cube[6][3][3]);move[counter]=9;counter++;
              turnFC(cube[6][3][3]);move[counter]=4;counter++;
          }
          correct = true;
          else if((cube[3][1][0]==b)&&(cube[5][1][2]==f))
          {

              turnLU(cube[6][3][3]);move[counter]=0;counter++;

          }
          correct = true;
          else if((cube[3][1][2]==b)&&(cube[4][1][2]==f))
          {

              turnBL(cube[6][3][3]);move[counter]=9;counter++;
              turnBL(cube[6][3][3]);move[counter]=9;counter++;
              turnLU(cube[6][3][3]);move[counter]=0;counter++;
          }
          correct = true;
          else if((cube[1][1][0]==b)&&(cube[5][1][0]==f))
          {

              turnLD(cube[6][3][3]);move[counter]=6;counter++;

          }
          correct = true;
          else if((cube[1][1][2]==b)&&(cube[4][1][0]==f))
          {

              turnFA(cube[6][3][3]);move[counter]=10;counter++;
              turnTR(cube[6][3][3]);move[counter]=2;counter++;
              turnTR(cube[6][3][3]);move[counter]=2;counter++;
              turnFA(cube[6][3][3]);move[counter]=10;counter++;
              turnLD(cube[6][3][3]);move[counter]=6;counter++;
          }
          correct = true;
           else if((cube[5][1][0]==b)&&(cube[1][1][0]==f))
          {

              turnFC(cube[6][3][3]);move[counter]=4;counter++;
              turnTL(cube[6][3][3]);move[counter]=8;counter++;
              turnFA(cube[6][3][3]);move[counter]=10;counter++;
              turnBA(cube[6][3][3]);move[counter]=11;counter++;
              turnLU(cube[6][3][3]);move[counter]=0;counter++;
              turnLU(cube[6][3][3]);move[counter]=0;counter++;
          }
          correct = true;
           else if((cube[4][1][0]==b)&&(cube[1][1][2]==f))
          {

              turnFA(cube[6][3][3]);move[counter]=10;counter++;
              turnRU(cube[6][3][3]);move[counter]=1;counter++;
              turnRU(cube[6][3][3]);move[counter]=1;counter++;
              turnBL(cube[6][3][3]);move[counter]=9;counter++;
              turnFC(cube[6][3][3]);move[counter]=4;counter++;

          }
          correct = true;
          else if((cube[3][2][1]==b)&&(cube[2][0][1]==f))
          {

              turnBR(cube[6][3][3]);move[counter]=3;counter++;
              turnLU(cube[6][3][3]);move[counter]=0;counter++;


          }
          correct = true;
          else if((cube[4][0][1]==b)&&(cube[2][1][2]==f))
          {

              turnBC(cube[6][3][3]);move[counter]=5;counter++;
              turnBR(cube[6][3][3]);move[counter]=3;counter++;
              turnLU(cube[6][3][3]);move[counter]=0;counter++;


          }
          correct = true;
          else if((cube[1][0][1]==b)&&(cube[2][2][1]==f))
          {

              turnBC(cube[6][3][3]);move[counter]=5;counter++;
              turnBC(cube[6][3][3]);move[counter]=5;counter++;
              turnBR(cube[6][3][3]);move[counter]=3;counter++;
              turnLU(cube[6][3][3]);move[counter]=0;counter++;


          }
          correct = true;
          else if((cube[5][2][1]==b)&&(cube[2][1][0]==f))
          {

              turnBA(cube[6][3][3]);move[counter]=11;counter++;
              turnBR(cube[6][3][3]);move[counter]=3;counter++;
              turnLU(cube[6][3][3]);move[counter]=0;counter++;
          }
          correct = true;
          else if((cube[2][0][1]==b)&&(cube[3][2][1]==f))
          {

              turnBC(cube[6][3][3]);move[counter]=5;counter++;
              turnLU(cube[6][3][3]);move[counter]=0;counter++;
              turnLU(cube[6][3][3]);move[counter]=0;counter++;


          }
          correct = true;
          else if((cube[2][1][0]==b)&&(cube[3][2][1]==f))
          {

              turnLU(cube[6][3][3]);move[counter]=0;counter++;
              turnLU(cube[6][3][3]);move[counter]=0;counter++;


          }
          correct = true;
          else if((cube[2][2][1]==b)&&(cube[1][0][1]==f))
          {

              turnFC(cube[6][3][3]);move[counter]=4;counter++;
              turnTR(cube[6][3][3]);move[counter]=2;counter++;
              turnFA(cube[6][3][3]);move[counter]=10;counter++;
              turnLD(cube[6][3][3]);move[counter]=6;counter++;


          }
          correct = true;
          else if((cube[2][1][2]==b)&&(cube[4][0][1]==f))
          {

              turnBC(cube[6][3][3]);move[counter]=5;counter++;
              turnBL(cube[6][3][3]);move[counter]=9;counter++;
              turnFA(cube[6][3][3]);move[counter]=10;counter++;
              turnBL(cube[6][3][3]);move[counter]=9;counter++;
              turnFC(cube[6][3][3]);move[counter]=4;counter++;

          }
          correct = true;
          else if((cube[3][0][1]==b)&&(cube[0][2][1]==f))
          {

              turnFC(cube[6][3][3]);move[counter]=4;counter++;
              turnLD(cube[6][3][3]);move[counter]=6;counter++;
              turnFA(cube[6][3][3]);move[counter]=10;counter++;
              turnLU(cube[6][3][3]);move[counter]=0;counter++;


          }
          correct = true;
          else if((cube[5][0][1]==b)&&(cube[0][1][0]==f))
          {

              turnFA(cube[6][3][3]);move[counter]=10;counter++;
              turnBL(cube[6][3][3]);move[counter]=9;counter++;
              turnFC(cube[6][3][3]);move[counter]=4;counter++;
              turnLU(cube[6][3][3]);move[counter]=0;counter++;

          }
          correct = true;
        }
           while(!correct);
 {

 if((cube[0][2][1]==b)&&(cube[3][0][1]==c))
        correct = true;
        else{
         else if((cube[4][1][2]==b)&&(cube[3][1][2]==c))
          {

              turnBL(cube[6][3][3]);move[counter]=9;counter++;

          }
          correct = true;
          else if((cube[3][1][2]==b)&&(cube[4][1][2]==c))
          {

              turnFA(cube[6][3][3]);move[counter]=10;counter++;
              turnRU(cube[6][3][3]);move[counter]=1;counter++;
              turnFC(cube[6][3][3]);move[counter]=4;counter++;
          }
          correct = true;
          else if((cube[4][0][1]==b)&&(cube[2][1][2]==c))
          {

              turnBC(cube[6][3][3]);move[counter]=5;counter++;
              turnBL(cube[6][3][3]);move[counter]=9;counter++;
              turnFA(cube[6][3][3]);move[counter]=10;counter++;
              turnRU(cube[6][3][3]);move[counter]=1;counter++;
              turnFC(cube[6][3][3]);move[counter]=4;counter++;
          }
          correct = true;
          else if((cube[2][1][2]==b)&&(cube[4][0][1]==c))
          {

              turnBC(cube[6][3][3]);move[counter]=5;counter++;
              turnBR(cube[6][3][3]);move[counter]=3;counter++;
              turnBR(cube[6][3][3]);move[counter]=3;counter++;

          }
          correct = true;
          else if((cube[4][1][0]==b)&&(cube[1][1][2]==c))
          {

              turnFA(cube[6][3][3]);move[counter]=10;counter++;
              turnRU(cube[6][3][3]);move[counter]=1;counter++;
              turnRU(cube[6][3][3]);move[counter]=1;counter++;
              turnFC(cube[6][3][3]);move[counter]=4;counter++;
              turnBL(cube[6][3][3]);move[counter]=9;counter++;
          }
          correct = true;
else if((cube[1][1][2]==b)&&(cube[4][1][0]==c))
          {


              turnFA(cube[6][3][3]);move[counter]=10;counter++;
              turnRD(cube[6][3][3]);move[counter]=7;counter++;
              turnFC(cube[6][3][3]);move[counter]=4;counter++;
          }
          correct = true;
          else if((cube[5][1][0]==b)&&(cube[1][1][0]==c))
          {

              turnFC(cube[6][3][3]);move[counter]=4;counter++;
              turnLU(cube[6][3][3]);move[counter]=0;counter++;
              turnLU(cube[6][3][3]);move[counter]=0;counter++;
              turnFA(cube[6][3][3]);move[counter]=10;counter++;
              turnBL(cube[6][3][3]);move[counter]=9;counter++;
          }
          correct = true;
          else if((cube[1][1][0]==b)&&(cube[5][1][0]==c))
          {

              turnFC(cube[6][3][3]);move[counter]=4;counter++;
              turnLD(cube[6][3][3]);move[counter]=6;counter++;
              turnFA(cube[6][3][3]);move[counter]=10;counter++;

          }
          correct = true;
          else if((cube[1][0][1]==b)&&(cube[2][2][1]==c))
          {

              turnBC(cube[6][3][3]);move[counter]=5;counter++;
              turnFA(cube[6][3][3]);move[counter]=10;counter++;
              turnLU(cube[6][3][3]);move[counter]=0;counter++;
              turnFC(cube[6][3][3]);move[counter]=4;counter++;
              turnBL(cube[6][3][3]);move[counter]=9;counter++;
          }
          correct = true;
          else if((cube[2][2][1]==b)&&(cube[1][0][1]==c))
          {

              turnBC(cube[6][3][3]);move[counter]=5;counter++;
              turnBC(cube[6][3][3]);move[counter]=5;counter++;
              turnBR(cube[6][3][3]);move[counter]=3;counter++;
              turnBR(cube[6][3][3]);move[counter]=3;counter++;

          }
          correct = true;
          else if((cube[2][0][1]==b)&&(cube[3][2][1]==c))
          {

              turnBR(cube[6][3][3]);move[counter]=3;counter++;
              turnBR(cube[6][3][3]);move[counter]=3;counter++;

          }
          correct = true;
          else if((cube[3][2][1]==b)&&(cube[2][0][1]==c))
          {


              turnBL(cube[6][3][3]);move[counter]=9;counter++;
              turnFA(cube[6][3][3]);move[counter]=10;counter++;
              turnRU(cube[6][3][3]);move[counter]=1;counter++;
              turnFC(cube[6][3][3]);move[counter]=4;counter++;
          }
          correct = true;
          else if((cube[2][1][0]==b)&&(cube[5][2][1]==c))
          {

              turnBA(cube[6][3][3]);move[counter]=11;counter++;
              turnBR(cube[6][3][3]);move[counter]=3;counter++;
              turnBR(cube[6][3][3]);move[counter]=3;counter++;

          }
          correct = true;
          else if((cube[5][2][1]==b)&&(cube[2][1][0]==c))
          {

              turnFC(cube[6][3][3]);move[counter]=4;counter++;
              turnLU(cube[6][3][3]);move[counter]=0;counter++;
              turnFA(cube[6][3][3]);move[counter]=10;counter++;
              turnBR(cube[6][3][3]);move[counter]=3;counter++;

          }
          correct = true;
          else if((cube[5][1][2]==b)&&(cube[3][1][0]==c))
          {

              turnBR(cube[6][3][3]);move[counter]=3;counter++;

          }
          correct = true;
          else if((cube[3][1][0]==b)&&(cube[5][1][2]==c))
          {

              turnBR(cube[6][3][3]);move[counter]=3;counter++;
              turnFC(cube[6][3][3]);move[counter]=4;counter++;
              turnLD(cube[6][3][3]);move[counter]=6;counter++;
              turnFA(cube[6][3][3]);move[counter]=10;counter++;
              turnBR(cube[6][3][3]);move[counter]=3;counter++;
          }
          correct = true;else if((cube[3][0][1]==b)&&(cube[0][2][0]==c))
          {

              turnBR(cube[6][3][3]);move[counter]=3;counter++;
              turnFA(cube[6][3][3]);move[counter]=1;counter++;
              turnRU(cube[6][3][3]);move[counter]=10;counter++;
              turnFC(cube[6][3][3]);move[counter]=4;counter++;

          }
          correct = true;

        }

                      while(!correct);
 {

 if((cube[1][2][2]==a)&&(cube[0][0][1]==2)&&(cube[4][2][0]==d))
        correct = true;
        else{
        %&%$&^% else if((cube[0][0][2]==a)&&(cube[4][2][0]==b)&&(cube[1][2][2])==d))
          {

              turnRU(cube[6][3][3]);move[counter]=1;counter++;
              turnBA(cube[6][3][3]);move[counter]=11;counter++;
              turnRD(cube[6][3][3]);move[counter]=7;counter++;
              turnBC(cube[6][3][3]);move[counter]=5;counter++;
              turnTR(cube[6][3][3]);move[counter]=2;counter++;
              turnBA(cube[6][3][3]);move[counter]=11;counter++;
              turnTL(cube[6][3][3]);move[counter]=8;counter++;

          }
          correct = true;

else if((cube[4][2][0]==a)&&(cube[1][2][2]==b)&&(cube[0][0][2])==d))
          {

              turnTR(cube[6][3][3]);move[counter]=2;counter++;
              turnBC(cube[6][3][3]);move[counter]=5;counter++;
              turnTL(cube[6][3][3]);move[counter]=8;counter++;
              turnBA(cube[6][3][3]);move[counter]=11;counter++;
              turnBA(cube[6][3][3]);move[counter]=11;counter++;
              turnRU(cube[6][3][3]);move[counter]=1;counter++;
              turnBC(cube[6][3][3]);move[counter]=5;counter++;
              turnRD(cube[6][3][3]);move[counter]=7;counter++;

          }
          correct = true;
          else if((cube[5][0][0]==a)&&(cube[0][0][0]==b)&&(cube[1][2][0])==d))
          {

              turnLU(cube[6][3][3]);move[counter]=0;counter++;
              turnBA(cube[6][3][3]);move[counter]=11;counter++;
              turnLD(cube[6][3][3]);move[counter]=6;counter++;
              turnBC(cube[6][3][3]);move[counter]=5;counter++;
              turnBC(cube[6][3][3]);move[counter]=5;counter++;
              turnTR(cube[6][3][3]);move[counter]=2;counter++;
              turnBA(cube[6][3][3]);move[counter]=11;counter++;
              turnTL(cube[6][3][3]);move[counter]=8;counter++;

          }
          correct = true;
          else if((cube[0][0][0]==a)&&(cube[1][2][0]==b)&&(cube[5][0][0])==d))
          {

              turnLU(cube[6][3][3]);move[counter]=0;counter++;
              turnBA(cube[6][3][3]);move[counter]=11;counter++;
              turnLD(cube[6][3][3]);move[counter]=6;counter++;
              turnBC(cube[6][3][3]);move[counter]=5;counter++;
              turnBC(cube[6][3][3]);move[counter]=5;counter++;
              turnTR(cube[6][3][3]);move[counter]=2;counter++;
              turnBA(cube[6][3][3]);move[counter]=11;counter++;
              turnTL(cube[6][3][3]);move[counter]=8;counter++;

          }
          correct = true;
          else if((cube[1][2][0]==a)&&(cube[5][0][0]==b)&&(cube[0][0][0])==d))
          {

              turnLU(cube[6][3][3]);move[counter]=0;counter++;
              turnBC(cube[6][3][3]);move[counter]=5;counter++;
              turnLD(cube[6][3][3]);move[counter]=6;counter++;
              turnBA(cube[6][3][3]);move[counter]=11;counter++;
              turnRU(cube[6][3][3]);move[counter]=1;counter++;
              turnBC(cube[6][3][3]);move[counter]=5;counter++;

              turnRD(cube[6][3][3]);move[counter]=7;counter++;

          }
          correct = true;
          else if((cube[4][2][2]==a)&&(cube[0][2][2]==b)&&(cube[3][0][2])==d))
          {

              turnRD(cube[6][3][3]);move[counter]=7;counter++;
              turnBA(cube[6][3][3]);move[counter]=11;counter++;
              turnRU(cube[6][3][3]);move[counter]=1;counter++;
              turnBA(cube[6][3][3]);move[counter]=11;counter++;
              turnBA(cube[6][3][3]);move[counter]=11;counter++;
              turnRU(cube[6][3][3]);move[counter]=1;counter++;
              turnBC(cube[6][3][3]);move[counter]=5;counter++;
              turnRD(cube[6][3][3]);move[counter]=7;counter++;

          }
          correct = true;
          else if((cube[0][2][2]==a)&&(cube[3][0][2]==b)&&(cube[4][2][2])==d))
          {

              turnBR(cube[6][3][3]);move[counter]=3;counter++;
              turnBA(cube[6][3][3]);move[counter]=11;counter++;
              turnBL(cube[6][3][3]);move[counter]=9;counter++;
              turnBA(cube[6][3][3]);move[counter]=11;counter++;
              turnBC(cube[6][3][3]);move[counter]=5;counter++;
              turnTR(cube[6][3][3]);move[counter]=2;counter++;
              turnBA(cube[6][3][3]);move[counter]=11;counter++;
              turnTL(cube[6][3][3]);move[counter]=8;counter++;

          }
          correct = true;
          else if((cube[3][0][2]==a)&&(cube[4][2][2]==b)&&(cube[0][2][2])==d))
          {

              turnRD(cube[6][3][3]);move[counter]=7;counter++;
              turnBA(cube[6][3][3]);move[counter]=11;counter++;
              turnBA(cube[6][3][3]);move[counter]=11;counter++;
              turnRU(cube[6][3][3]);move[counter]=1;counter++;
              turnRU(cube[6][3][3]);move[counter]=1;counter++;
              turnBC(cube[6][3][3]);move[counter]=5;counter++;
              turnRD(cube[6][3][3]);move[counter]=7;counter++;


          }
          correct = true;
          else if((cube[3][0][0]==a)&&(cube[0][2][1]==b)&&(cube[5][0][2])==d))
          {

              turnBL(cube[6][3][3]);move[counter]=9;counter++;
              turnBC(cube[6][3][3]);move[counter]=5;counter++;
              turnBR(cube[6][3][3]);move[counter]=3;counter++;
              turnBC(cube[6][3][3]);move[counter]=5;counter++;
              turnBC(cube[6][3][3]);move[counter]=5;counter++;
              turnTR(cube[6][3][3]);move[counter]=2;counter++;
              turnBA(cube[6][3][3]);move[counter]=11;counter++;
              turnTL(cube[6][3][3]);move[counter]=8;counter++;

          }
          correct = true;
          else if((cube[0][2][1]==a)&&(cube[5][0][2]==b)&&(cube[3][0][0])==d))
          {

              turnLD(cube[6][3][3]);move[counter]=36;counter++;
              turnBA(cube[6][3][3]);move[counter]=11;counter++;
              turnLU(cube[6][3][3]);move[counter]=0;counter++;
              turnTR(cube[6][3][3]);move[counter]=2;counter++;
              turnBA(cube[6][3][3]);move[counter]=11;counter++;
              turnTL(cube[6][3][3]);move[counter]=8;counter++;


          }
          correct = true;
          else if((cube[5][0][2]==a)&&(cube[3][0][0]==b)&&(cube[0][2][1])==d))
          {

              turnBL(cube[6][3][3]);move[counter]=9;counter++;
              turnBC(cube[6][3][3]);move[counter]=5;counter++;
              turnBR(cube[6][3][3]);move[counter]=3;counter++;
              turnRU(cube[6][3][3]);move[counter]=1;counter++;
              turnBC(cube[6][3][3]);move[counter]=5;counter++;
              turnRD(cube[6][3][3]);move[counter]=7;counter++;


          }
          correct = true;
          else if((cube[1][0][0]==a)&&(cube[2][2][0]==b)&&(cube[5][2][0])==d))
          {

              turnLU(cube[6][3][3]);move[counter]=0;counter++;
              turnBC(cube[6][3][3]);move[counter]=5;counter++;
              turnBC(cube[6][3][3]);move[counter]=11;counter++;
              turnLD(cube[6][3][3]);move[counter]=6;counter++;
              turnBA(cube[6][3][3]);move[counter]=11;counter++;
              turnRU(cube[6][3][3]);move[counter]=1;counter++;
              turnBC(cube[6][3][3]);move[counter]=5;counter++;
              turnRD(cube[6][3][3]);move[counter]=7;counter++;

          }
          correct = true;
          else if((cube[5][2][0]==a)&&(cube[1][0][0]==b)&&(cube[2][2][0])==d))
          {

              turnBC(cube[6][3][3]);move[counter]=5;counter++;
              turnBC(cube[6][3][3]);move[counter]=5;counter++;
              turnTR(cube[6][3][3]);move[counter]=2;counter++;
              turnBA(cube[6][3][3]);move[counter]=11;counter++;
              turnTL(cube[6][3][3]);move[counter]=8;counter++;


          }
          correct = true;
          else if((cube[2][2][0]==a)&&(cube[5][2][0]==b)&&(cube[1][0][0])==d))
          {

              turnRU(cube[6][3][3]);move[counter]=1;counter++;
              turnBC(cube[6][3][3]);move[counter]=5;counter++;
              turnRD(cube[6][3][3]);move[counter]=7;counter++;


          }
          correct = true;
          else if((cube[2][0][0]==a)&&(cube[3][2][0]==b)&&(cube[5][2][2])==d))
          {

              turnRU(cube[6][3][3]);move[counter]=1;counter++;
              turnBC(cube[6][3][3]);move[counter]=5;counter++;
              turnBC(cube[6][3][3]);move[counter]=5;counter++;
              turnRD(cube[6][3][3]);move[counter]=7;counter++;


          }
          correct = true;
          else if((cube[5][2][2]==a)&&(cube[2][0][0]==b)&&(cube[3][2][0])==d))
          {

              turnLD(cube[6][3][3]);move[counter]=6;counter++;
              turnBC(cube[6][3][3]);move[counter]=5;counter++;
              turnLU(cube[6][3][3]);move[counter]=0;counter++;
              turnBC(cube[6][3][3]);move[counter]=5;counter++;

              turnTR(cube[6][3][3]);move[counter]=2;counter++;
              turnBA(cube[6][3][3]);move[counter]=11;counter++;
              turnTL(cube[6][3][3]);move[counter]=8;counter++;

          }
          correct = true;
          else if((cube[3][2][0]==a)&&(cube[5][2][2]==b)&&(cube[2][0][0])==d))
          {

              turnTR(cube[6][3][3]);move[counter]=2;counter++;
              turnBC(cube[6][3][3]);move[counter]=5;counter++;
              turnBC(cube[6][3][3]);move[counter]=5;counter++;
              turnTL(cube[6][3][3]);move[counter]=8;counter++;


          }
          correct = true;
          else if((cube[3][2][2]==a)&&(cube[2][0][2]==b)&&(cube[4][0][2])==d))
          {

              turnRD(cube[6][3][3]);move[counter]=7;counter++;
              turnBA(cube[6][3][3]);move[counter]=11;counter++;
              turnRU(cube[6][3][3]);move[counter]=1;counter++;
              turnRU(cube[6][3][3]);move[counter]=1;counter++;
              turnBC(cube[6][3][3]);move[counter]=5;counter++;
              turnRD(cube[6][3][3]);move[counter]=7;counter++;

          }
          correct = true;
          else if((cube[4][0][2]==a)&&(cube[3][2][2]==b)&&(cube[2][0][2])==d))
          {


              turnTR(cube[6][3][3]);move[counter]=2;counter++;
              turnBA(cube[6][3][3]);move[counter]=11;counter++;
              turnTL(cube[6][3][3]);move[counter]=8;counter++;

          }
          correct = true;
          else if((cube[2][0][2]==a)&&(cube[4][0][2]==b)&&(cube[3][2][2])==d))
          {


              turnBA(cube[6][3][3]);move[counter]=11;counter++;
              turnBA(cube[6][3][3]);move[counter]=11;counter++;
              turnRU(cube[6][3][3]);move[counter]=1;counter++;
              turnBC(cube[6][3][3]);move[counter]=5;counter++;
              turnRD(cube[6][3][3]);move[counter]=7;counter++;


          }
          correct = true;
          else if((cube[4][0][0]==a)&&(cube[2][2][2]==b)&&(cube[1][0][2])==d))
          {

              turnRU(cube[6][3][3]);move[counter]=1;counter++;
              turnBC(cube[6][3][3]);move[counter]=5;counter++;
              turnRD(cube[6][3][3]);move[counter]=7;counter++;
              turnTR(cube[6][3][3]);move[counter]=2;counter++;
              turnBC(cube[6][3][3]);move[counter]=5;counter++;
              turnBC(cube[6][3][3]);move[counter]=5;counter++;
              turnTL(cube[6][3][3]);move[counter]=8;counter++;


          }
          correct = true;
          else if((cube[2][2][2]==a)&&(cube[1][0][2]==b)&&(cube[4][0][0])==d))
          {


              turnBA(cube[6][3][3]);move[counter]=11;counter++;
              turnRU(cube[6][3][3]);move[counter]=1;counter++;
              turnBC(cube[6][3][3]);move[counter]=5;counter++;
              turnRD(cube[6][3][3]);move[counter]=7;counter++;

          }
          correct = true;
          else if((cube[1][0][2]==a)&&(cube[4][0][0]==b)&&(cube[2][2][2])==d))
          {

              turnBC(cube[6][3][3]);move[counter]=5;counter++;
              turnTR(cube[6][3][3]);move[counter]=3;counter++;
              turnBA(cube[6][3][3]);move[counter]=11;counter++;
              turnTL(cube[6][3][3]);move[counter]=8;counter++;


          }
          correct = true;
        }
                   while(!correct);
 {

 if((cube[1][2][0]==b)&&(cube[0][0][0]==f)&&(cube[5][0][0]==a))
        correct = true;
        else{
         else if((cube[0][0][0]==b)&&(cube[5][0][0]==f)&&(cube[1][2][0]==a))
          {

              turnLU(cube[6][3][3]);move[counter]=0;counter++;
              turnBC(cube[6][3][3]);move[counter]=5;counter++;
              turnLD(cube[6][3][3]);move[counter]=6;counter++;
              turnBA(cube[6][3][3]);move[counter]=11;counter++;
              turnBA(cube[6][3][3]);move[counter]=11;counter++;
              turnTL(cube[6][3][3]);move[counter]=8;counter++;
              turnBC(cube[6][3][3]);move[counter]=5;counter++;
              turnTR(cube[6][3][3]);move[counter]=2;counter++;

          }
          correct = true;
          else if((cube[5][0][0]==b)&&(cube[1][2][0]==f)&&(cube[0][0][0]==a))
          {

              turnTL(cube[6][3][3]);move[counter]=8;counter++;
              turnBA(cube[6][3][3]);move[counter]=11;counter++;
              turnTR(cube[6][3][3]);move[counter]=2;counter++;
              turnBC(cube[6][3][3]);move[counter]=5;counter++;
              turnBC(cube[6][3][3]);move[counter]=5;counter++;
              turnLU(cube[6][3][3]);move[counter]=0;counter++;
              turnBA(cube[6][3][3]);move[counter]=11;counter++;
              turnLD(cube[6][3][3]);move[counter]=6;counter++;

          }
          correct = true;
          else if((cube[0][2][1]==b)&&(cube[3][0][0]==f)&&(cube[5][0][2]==a))
          {

              turnLD(cube[6][3][3]);move[counter]=6;counter++;
              turnBC(cube[6][3][3]);move[counter]=5;counter++;
              turnLU(cube[6][3][3]);move[counter]=0;counter++;
              turnBC(cube[6][3][3]);move[counter]=5;counter++;
              turnBC(cube[6][3][3]);move[counter]=5;counter++;
              turnLU(cube[6][3][3]);move[counter]=0;counter++;
              turnBA(cube[6][3][3]);move[counter]=11;counter++;
              turnLD(cube[6][3][3]);move[counter]=6;counter++;

          }
          correct = true;
          else if((cube[3][0][0]==b)&&(cube[5][0][2]==f)&&(cube[0][2][1]==a))
          {

              turnLD(cube[6][3][3]);move[counter]=6;counter++;
              turnBA(cube[6][3][3]);move[counter]=11;counter++;
              turnLU(cube[6][3][3]);move[counter]=0;counter++;
              turnRD(cube[6][3][3]);move[counter]=7;counter++;
              turnBA(cube[6][3][3]);move[counter]=11;counter++;
              turnRU(cube[6][3][3]);move[counter]=1;counter++;
              turnBA(cube[6][3][3]);move[counter]=11;counter++;
              turnTL(cube[6][3][3]);move[counter]=8;counter++;
              turnBC(cube[6][3][3]);move[counter]=5;counter++;
              turnTR(cube[6][3][3]);move[counter]=2;counter++;

          }
          correct = true;
          else if((cube[5][0][2]==b)&&(cube[0][2][1]==f)&&(cube[3][0][0]==a))
          {

              turnLD(cube[6][3][3]);move[counter]=6;counter++;
              turnBA(cube[6][3][3]);move[counter]=11;counter++;
              turnLU(cube[6][3][3]);move[counter]=0;counter++;
              turnLU(cube[6][3][3]);move[counter]=0;counter++;
              turnBC(cube[6][3][3]);move[counter]=5;counter++;
              turnBC(cube[6][3][3]);move[counter]=5;counter++;
              turnLD(cube[6][3][3]);move[counter]=6;counter++;


          }
          correct = true;
          else if((cube[0][2][2]==b)&&(cube[4][2][2]==f)&&(cube[3][0][2]==a))
          {

              turnRD(cube[6][3][3]);move[counter]=7;counter++;
              turnBA(cube[6][3][3]);move[counter]=11;counter++;
              turnRU(cube[6][3][3]);move[counter]=1;counter++;
              turnTL(cube[6][3][3]);move[counter]=8;counter++;
              turnBA(cube[6][3][3]);move[counter]=11;counter++;
              turnBA(cube[6][3][3]);move[counter]=11;counter++;
              turnTR(cube[6][3][3]);move[counter]=2;counter++;

          }
          correct = true;
          else if((cube[4][2][2]==b)&&(cube[3][0][2]==f)&&(cube[0][2][2]==a))
          {

              turnRD(cube[6][3][3]);move[counter]=7;counter++;
              turnBC(cube[6][3][3]);move[counter]=5;counter++;
              turnRU(cube[6][3][3]);move[counter]=1;counter++;
              turnBA(cube[6][3][3]);move[counter]=11;counter++;
              turnTL(cube[6][3][3]);move[counter]=8;counter++;
              turnBA(cube[6][3][3]);move[counter]=11;counter++;
              turnBA(cube[6][3][3]);move[counter]=11;counter++;
              turnTR(cube[6][3][3]);move[counter]=2;counter++;

          }
          correct = true;
          else if((cube[3][0][2]==b)&&(cube[0][2][2]==f)&&(cube[4][2][2]==a))
          {

              turnBR(cube[6][3][3]);move[counter]=3;counter++;
              turnBA(cube[6][3][3]);move[counter]=11;counter++;
              turnBL(cube[6][3][3]);move[counter]=9;counter++;
              turnLU(cube[6][3][3]);move[counter]=0;counter++;
              turnBA(cube[6][3][3]);move[counter]=11;counter++;
              turnLD(cube[6][3][3]);move[counter]=6;counter++;


          }
          correct = true;
          else if((cube[3][2][0]==b)&&(cube[2][0][0]==f)&&(cube[5][2][2]==a))
          {

              turnTL(cube[6][3][3]);move[counter]=8;counter++;
              turnBC(cube[6][3][3]);move[counter]=5;counter++;
              turnTR(cube[6][3][3]);move[counter]=2;counter++;


          }
          correct = true;
          else if((cube[2][0][0]==b)&&(cube[5][2][2]==f)&&(cube[3][2][0]==a))
          {

              turnLD(cube[6][3][3]);move[counter]=6;counter++;
              turnBC(cube[6][3][3]);move[counter]=5;counter++;
              turnLU(cube[6][3][3]);move[counter]=0;counter++;
              turnLU(cube[6][3][3]);move[counter]=0;counter++;
              turnBA(cube[6][3][3]);move[counter]=11;counter++;
              turnLD(cube[6][3][3]);move[counter]=6;counter++;


          }
          correct = true;
          else if((cube[5][2][2]==b)&&(cube[3][2][0]==f)&&(cube[2][0][0]==a))
          {

              turnBC(cube[6][3][3]);move[counter]=5;counter++;
              turnBC(cube[6][3][3]);move[counter]=5;counter++;
              turnLU(cube[6][3][3]);move[counter]=0;counter++;
              turnBA(cube[6][3][3]);move[counter]=11;counter++;
              turnLD(cube[6][3][3]);move[counter]=6;counter++;


          }
          correct = true;
          else if((cube[4][0][2]==b)&&(cube[2][0][2]==f)&&(cube[3][2][2]==a))
          {


              turnTL(cube[6][3][3]);move[counter]=8;counter++;
              turnBA(cube[6][3][3]);move[counter]=11;counter++;
              turnBA(cube[6][3][3]);move[counter]=11;counter++;
              turnTR(cube[6][3][3]);move[counter]=2;counter++;

          }
          correct = true;
          else if((cube[3][2][2]==b)&&(cube[4][0][2]==f)&&(cube[2][0][2]==a))
          {

              turnLU(cube[6][3][3]);move[counter]=0;counter++;
              turnBA(cube[6][3][3]);move[counter]=11;counter++;
              turnBA(cube[6][3][3]);move[counter]=11;counter++;
              turnLD(cube[6][3][3]);move[counter]=6;counter++;

          }
          correct = true;
          else if((cube[2][0][2]==b)&&(cube[3][2][2]==f)&&(cube[4][0][2]==a))
          {

              turnRD(cube[6][3][3]);move[counter]=7;counter++;
              turnBA(cube[6][3][3]);move[counter]=11;counter++;
              turnRU(cube[6][3][3]);move[counter]=1;counter++;
              turnBA(cube[6][3][3]);move[counter]=11;counter++;
              turnTL(cube[6][3][3]);move[counter]=8;counter++;
              turnBC(cube[6][3][3]);move[counter]=5;counter++;
              turnTR(cube[6][3][3]);move[counter]=2;counter++;

          }
          correct = true;
          else if((cube[1][0][0]==b)&&(cube[5][2][0]==f)&&(cube[2][2][0]==a))
          {

              turnBC(cube[6][3][3]);move[counter]=5;counter++;
              turnLU(cube[6][3][3]);move[counter]=0;counter++;
              turnBA(cube[6][3][3]);move[counter]=11;counter++;
              turnLD(cube[6][3][3]);move[counter]=6;counter++;


          }
          correct = true;
          else if((cube[2][2][0]==b)&&(cube[1][0][0]==f)&&(cube[5][2][0]==a))
          {

              turnLU(cube[6][3][3]);move[counter]=0;counter++;
              turnBA(cube[6][3][3]);move[counter]=11;counter++;
              turnLD(cube[6][3][3]);move[counter]=6;counter++;
              turnTL(cube[6][3][3]);move[counter]=8;counter++;

              turnBA(cube[6][3][3]);move[counter]=11;counter++;
              turnBA(cube[6][3][3]);move[counter]=11;counter++;
              turnTR(cube[6][3][3]);move[counter]=2;counter++;

          }
          correct = true;
          else if((cube[5][2][0]==b)&&(cube[2][2][0]==f)&&(cube[1][0][0]==a))
          {

              turnBL(cube[6][3][3]);move[counter]=9;counter++;
              turnTL(cube[6][3][3]);move[counter]=8;counter++;
              turnBC(cube[6][3][3]);move[counter]=5;counter++;
              turnTR(cube[6][3][3]);move[counter]=2;counter++;

          }
          correct = true;
          else if((cube[4][0][0]==b)&&(cube[1][0][2]==f)&&(cube[2][2][2]==a))
          {

              turnLU(cube[6][3][3]);move[counter]=0;counter++;
              turnBA(cube[6][3][3]);move[counter]=11;counter++;
              turnLD(cube[6][3][3]);move[counter]=6;counter++;

          }
          correct = true;
          else if((cube[1][0][2]==b)&&(cube[2][2][2]==f)&&(cube[4][0][0]==a))
          {

              turnBC(cube[6][3][3]);move[counter]=5;counter++;
              turnTL(cube[6][3][3]);move[counter]=8;counter++;
              turnBA(cube[6][3][3]);move[counter]=11;counter++;
              turnBA(cube[6][3][3]);move[counter]=11;counter++;
              turnTR(cube[6][3][3]);move[counter]=2;counter++;

          }
          correct = true;

    else if((cube[2][2][2]==b)&&(cube[4][0][0]==f)&&(cube[1][0][2]==a))
          {

              turnBA(cube[6][3][3]);move[counter]=11;counter++;
              turnLU(cube[6][3][3]);move[counter]=0;counter++;
              turnBC(cube[6][3][3]);move[counter]=5;counter++;
              turnBC(cube[6][3][3]);move[counter]=5;counter++;
              turnLD(cube[6][3][3]);move[counter]=6;counter++;
              turnBC(cube[6][3][3]);move[counter]=5;counter++;
              turnTL(cube[6][3][3]);move[counter]=8;counter++;
              turnBA(cube[6][3][3]);move[counter]=11;counter++;
              turnBA(cube[6][3][3]);move[counter]=11;counter++;
              turnTR(cube[6][3][3]);move[counter]=2;counter++;

          }
          correct = true;
        }

                             while(!correct);
 {

 if((cube[0][2][1]==b)&&(cube[3][0][0]==c)&&(cube[5][0][2]==f))
        correct = true;
        else{
         else if((cube[3][0][0]==b)&&(cube[5][0][2]==c)&&(cube[0][2][1]==f))
          {

              turnBL(cube[6][3][3]);move[counter]=9;counter++;
              turnBC(cube[6][3][3]);move[counter]=5;counter++;
              turnBR(cube[6][3][3]);move[counter]=3;counter++;
              turnBC(cube[6][3][3]);move[counter]=5;counter++;
              turnLD(cube[6][3][3]);move[counter]=6;counter++;
              turnBA(cube[6][3][3]);move[counter]=11;counter++;
              turnBA(cube[6][3][3]);move[counter]=11;counter++;
              turnLU(cube[6][3][3]);move[counter]=0;counter++;

          }
          correct = true;
else if((cube[5][0][2]==b)&&(cube[0][2][1]==c)&&(cube[3][0][0]==f))
          {

              turnLD(cube[6][3][3]);move[counter]=6;counter++;
              turnBA(cube[6][3][3]);move[counter]=11;counter++;
              turnLU(cube[6][3][3]);move[counter]=0;counter++;
              turnBA(cube[6][3][3]);move[counter]=11;counter++;
              turnBL(cube[6][3][3]);move[counter]=9;counter++;
              turnBA(cube[6][3][3]);move[counter]=11;counter++;
              turnBA(cube[6][3][3]);move[counter]=11;counter++;
              turnBR(cube[6][3][3]);move[counter]=3;counter++;

          }
          correct = true;
          else if((cube[3][2][0]==b)&&(cube[2][0][0]==c)&&(cube[5][2][2]==f))
          {

              turnBA(cube[6][3][3]);move[counter]=11;counter++;
              turnLD(cube[6][3][3]);move[counter]=6;counter++;
              turnBC(cube[6][3][3]);move[counter]=5;counter++;
              turnLU(cube[6][3][3]);move[counter]=0;counter++;


          }
          correct = true;
          else if((cube[2][0][0]==b)&&(cube[5][2][2]==c)&&(cube[3][2][0]==f))
          {

              turnLD(cube[6][3][3]);move[counter]=6;counter++;
              turnBC(cube[6][3][3]);move[counter]=5;counter++;
              turnLU(cube[6][3][3]);move[counter]=0;counter++;
              turnBL(cube[6][3][3]);move[counter]=9;counter++;
              turnBA(cube[6][3][3]);move[counter]=11;counter++;
              turnBA(cube[6][3][3]);move[counter]=11;counter++;
              turnBR(cube[6][3][3]);move[counter]=3;counter++;


          }
          correct = true;
          else if((cube[5][2][2]==b)&&(cube[3][2][0]==c)&&(cube[2][0][0]==f))
          {

              turnBC(cube[6][3][3]);move[counter]=5;counter++;
              turnBL(cube[6][3][3]);move[counter]=9;counter++;
              turnBA(cube[6][3][3]);move[counter]=11;counter++;
              turnBR(cube[6][3][3]);move[counter]=3;counter++;


          }
          correct = true;
          else if((cube[4][0][2]==b)&&(cube[2][0][2]==c)&&(cube[3][2][2]==f))
          {


              turnLD(cube[6][3][3]);move[counter]=6;counter++;
              turnBC(cube[6][3][3]);move[counter]=5;counter++;
              turnLU(cube[6][3][3]);move[counter]=0;counter++;

          }
          correct = true;
          else if((cube[3][2][2]==b)&&(cube[4][0][2]==c)&&(cube[2][0][2]==f))
          {

              turnBC(cube[6][3][3]);move[counter]=5;counter++;
              turnBC(cube[6][3][3]);move[counter]=5;counter++;
              turnBL(cube[6][3][3]);move[counter]=9;counter++;
              turnBA(cube[6][3][3]);move[counter]=11;counter++;
              turnBL(cube[6][3][3]);move[counter]=9;counter++;


          }
          correct = true;
          else if((cube[2][0][2]==b)&&(cube[3][2][2]==c)&&(cube[4][0][2]==f))
          {

              turnBC(cube[6][3][3]);move[counter]=5;counter++;
              turnLD(cube[6][3][3]);move[counter]=6;counter++;
              turnBC(cube[6][3][3]);move[counter]=35;counter++;
              turnLU(cube[6][3][3]);move[counter]=0;counter++;
              turnBL(cube[6][3][3]);move[counter]=9;counter++;
              turnBA(cube[6][3][3]);move[counter]=11;counter++;
              turnBA(cube[6][3][3]);move[counter]=11;counter++;


          }
          correct = true;
          else if((cube[1][0][0]==b)&&(cube[5][2][0]==c)&&(cube[2][2][0]==f))
          {

              turnBL(cube[6][3][3]);move[counter]=9;counter++;

              turnBA(cube[6][3][3]);move[counter]=11;counter++;
              turnBR(cube[6][3][3]);move[counter]=3;counter++;


          }
          correct = true;
          else if((cube[2][2][0]==b)&&(cube[1][0][0]==c)&&(cube[5][2][0]==f))
          {

              turnBA(cube[6][3][3]);move[counter]=11;counter++;
              turnBL(cube[6][3][3]);move[counter]=9;counter++;
              turnBA(cube[6][3][3]);move[counter]=11;counter++;
              turnBR(cube[6][3][3]);move[counter]=3;counter++;
              turnLD(cube[6][3][3]);move[counter]=6;counter++;
              turnBA(cube[6][3][3]);move[counter]=11;counter++;
              turnBA(cube[6][3][3]);move[counter]=11;counter++;
              turnLU(cube[6][3][3]);move[counter]=0;counter++;

          }
          correct = true;
          else if((cube[5][2][0]==b)&&(cube[2][2][0]==c)&&(cube[1][0][0]==f))
          {

              turnBC(cube[6][3][3]);move[counter]=5;counter++;
              turnLD(cube[6][3][3]);move[counter]=6;counter++;
              turnBA(cube[6][3][3]);move[counter]=11;counter++;
              turnBA(cube[6][3][3]);move[counter]=11;counter++;
              turnLU(cube[6][3][3]);move[counter]=0;counter++;


          }
          correct = true;
          else if((cube[4][0][0]==b)&&(cube[1][0][2]==c)&&(cube[2][2][2]==f))
          {

              turnBL(cube[6][3][3]);move[counter]=9;counter++;

              turnBA(cube[6][3][3]);move[counter]=11;counter++;
              turnBA(cube[6][3][3]);move[counter]=11;counter++;
              turnBR(cube[6][3][3]);move[counter]=3;counter++;

          }
          correct = true;
          else if((cube[1][0][2]==b)&&(cube[2][2][2]==c)&&(cube[4][0][0]==f))
          {


              turnLD(cube[6][3][3]);move[counter]=6;counter++;
              turnBA(cube[6][3][3]);move[counter]=11;counter++;
              turnBA(cube[6][3][3]);move[counter]=11;counter++;
              turnLU(cube[6][3][3]);move[counter]=0;counter++;

          }
          correct = true;
          else if((cube[2][2][2]==b)&&(cube[4][0][0]==c)&&(cube[1][0][2]==f))
          {

              turnBC(cube[6][3][3]);move[counter]=5;counter++;
              turnBC(cube[6][3][3]);move[counter]=5;counter++;
              turnLD(cube[6][3][3]);move[counter]=6;counter++;
              turnBC(cube[6][3][3]);move[counter]=5;counter++;
              turnLU(cube[6][3][3]);move[counter]=0;counter++;
              turnBL(cube[6][3][3]);move[counter]=9;counter++;
              turnBA(cube[6][3][3]);move[counter]=11;counter++;
              turnBA(cube[6][3][3]);move[counter]=11;counter++;
              turnBR(cube[6][3][3]);move[counter]=3;counter++;

          }
          correct = true;
                  }

                             while(!correct);
 {

 if((cube[0][2][2]==b)&&(cube[4][2][2]==c)&&(cube[3][0][2]==f))
        correct = true;
        else{
         else if((cube[0][2][1]==b)&&(cube[3][0][0]==c)&&(cube[5][0][2]==f))
          {

              turnLD(cube[6][3][3]);move[counter]=6;counter++;
              turnBA(cube[6][3][3]);move[counter]=11;counter++;
              turnLU(cube[6][3][3]);move[counter]=0;counter++;
              turnBA(cube[6][3][3]);move[counter]=11;counter++;
              turnBR(cube[6][3][3]);move[counter]=3;counter++;
              turnBC(cube[6][3][3]);move[counter]=5;counter++;
              turnBL(cube[6][3][3]);move[counter]=9;counter++;


          }
          correct = true;
                   else if((cube[3][0][0]==b)&&(cube[5][0][2]==c)&&(cube[0][2][1]==f))
          {

              turnBL(cube[6][3][3]);move[counter]=9;counter++;
              turnBC(cube[6][3][3]);move[counter]=5;counter++;
              turnBR(cube[6][3][3]);move[counter]=3;counter++;
              turnBR(cube[6][3][3]);move[counter]=3;counter++;
              turnBC(cube[6][3][3]);move[counter]=5;counter++;
              turnBC(cube[6][3][3]);move[counter]=5;counter++;
              turnBL(cube[6][3][3]);move[counter]=9;counter++;


          }
          correct = true;
                   else if((cube[5][0][2]==b)&&(cube[0][2][1]==c)&&(cube[3][0][0]==f))
          {

              turnLD(cube[6][3][3]);move[counter]=6;counter++;
              turnBA(cube[6][3][3]);move[counter]=11;counter++;
              turnLU(cube[6][3][3]);move[counter]=0;counter++;
              turnBC(cube[6][3][3]);move[counter]=5;counter++;
              turnRD(cube[6][3][3]);move[counter]=7;counter++;
              turnBA(cube[6][3][3]);move[counter]=11;counter++;
              turnRU(cube[6][3][3]);move[counter]=1;counter++;


          }
          correct = true;
                   else if((cube[0][2][1]==b)&&(cube[3][0][0]==c)&&(cube[5][0][2]==f))
          {

              turnLD(cube[6][3][3]);move[counter]=6;counter++;
              turnBA(cube[6][3][3]);move[counter]=11;counter++;
              turnLU(cube[6][3][3]);move[counter]=0;counter++;
              turnBA(cube[6][3][3]);move[counter]=11;counter++;
              turnBR(cube[6][3][3]);move[counter]=3;counter++;
              turnBC(cube[6][3][3]);move[counter]=5;counter++;
              turnBL(cube[6][3][3]);move[counter]=9;counter++;


          }
          correct = true;


*/
