
#include <allegro5/allegro.h>                             //Main Allegro header
#include <allegro5/allegro_native_dialog.h>   //Header for dialogue boxes
#include <iostream>
#include <allegro5/allegro_ttf.h>
#include <allegro5/allegro_font.h>
#include <allegro5/allegro_primitives.h>
int main()
{
    int screenwidth=800,screeinheight=600;
     //This is the display on which you draw everyting
    ALLEGRO_DISPLAY *display;

     //If Allegro fails to initialize show a message box
    if(!al_init())
        al_show_native_message_box(NULL, NULL, NULL, "Could not initialize Allegro 5", NULL,NULL);
    //Define the display
    //al_set_new_display_flags();
    display = al_create_display(screenwidth,screeinheight);
    al_set_window_title(display,"RUBIKS");
    al_set_window_position(display,0,0);
    //If Allegro fails to create a display show a message box
    if(!display)
        al_show_native_message_box(NULL, NULL, NULL, "Could not create Allegro 5 display",NULL,NULL);
    //Show the application window for 10 seconds
    //(if you don't, the application will shut down immediately after you launch it)

    //al_install_keyboard();
    al_init_primitives_addon();
    al_install_mouse();

    ALLEGRO_EVENT_QUEUE *event1=al_create_event_queue();
    ALLEGRO_TIMER *timer=al_create_timer(1.0/60);
    //al_register_event_source(event1,al_get_keyboard_event_source());
    al_register_event_source(event1,al_get_mouse_event_source());
    int x=10,y=10,movespeed=5;int dir=1;
    bool done=false,draw=true;
    al_register_event_source(event1,al_get_timer_event_source(timer));
    al_register_event_source(event1,al_get_display_event_source(display));
    al_start_timer(timer);
    while(!done)
    {
       ALLEGRO_EVENT events;
       al_wait_for_event(event1,&events);

       /*if(events.type==ALLEGRO_EVENT_KEY_DOWN)
       {
           switch(events.keyboard.keycode)
           {
              case ALLEGRO_KEY_DOWN:
              dir=1;break;
              case ALLEGRO_KEY_UP:
               dir=2;break;
              case ALLEGRO_KEY_RIGHT:
              dir=3;break;
              case ALLEGRO_KEY_LEFT:
              dir=4;break;
              case ALLEGRO_KEY_ESCAPE:
              done=true;break;
           }
       }*/
       if(events.type==ALLEGRO_EVENT_DISPLAY_CLOSE)
        done=true;
       /*if(events.type==ALLEGRO_EVENT_TIMER)
       {
           switch(dir)
           {
           case 1:
            y+=movespeed;break;
            case 2:
            y-=movespeed;break;
            case 3:
            x+=movespeed;break;
            case 4:
            x-=movespeed;break;
           }draw=true;
       }*/
    else if(events.type==ALLEGRO_EVENT_MOUSE_AXES)
    {
        x=events.mouse.x;
        y=events.mouse.y;
    }
    al_draw_rectangle(x,y,x+20,y+20,al_map_rgb(0,0,150),5.0);
    //al_init_font_addon();
    //al_init_ttf_addon();
    //al_init_primitives_addon();
    //ALLEGRO_FONT *font=al_load_font("Corbel.ttf",36,NULL);
    //al_draw_text(font,al_map_rgb(255,0,0),screenwidth/2,screeinheight/2,ALLEGRO_ALIGN_RIGHT,"RUBIKS CUBE");
    //al_draw_filled_triangle(20,20,40,20,30,30,al_map_rgb(0,255,0));
    //al_draw_filled_triangle(20,20,40,20,30,10,al_map_rgb(0,255,0));
    al_flip_display();
    al_clear_to_color(al_map_rgb(0,0,0));
    }


     //Deallocate the memory used for the display creation
    //al_destroy_font(font);
    al_destroy_timer(timer);
    al_destroy_event_queue(event1);
    al_destroy_display(display);


    return 0;
}

/*
#include <allegro5/allegro.h>                             //Main Allegro header
#include <allegro5/allegro_native_dialog.h>   //Header for dialogue boxes
#include <iostream>
#include <allegro5/allegro_ttf.h>
#include <allegro5/allegro_font.h>
#include <allegro5/allegro_primitives.h>
int main()
{
    ALLEGRO_DISPLAY *display;
    int sw=800,sh=600;
    if(!al_init())
        al_show_native_message_box(NULL, NULL, NULL, "Could not initialize Allegro 5", NULL,NULL);
    display = al_create_display(sw,sh);
    if(!display)
        al_show_native_message_box(NULL, NULL, NULL, "Could not create Allegro 5 display",NULL,NULL);
    al_set_window_title(display,"RUBIKS");
    al_init_primitives_addon();
    int i,j,x=sw/4,y=sh/4,x1=x+31.64,y1=y+20;
    for(i=0;i<6;i++)
    {
        for(j=0;j<3;j++)
        {
            al_draw_filled_triangle(x,y,x,y+40,x1,y1,al_map_rgb(0,0,255));
            y+=40;y1+=40;
        }
        if(i%2==0)
        {
            x=x+31.64;x1=x-31.64;y=y-100;y1-=100;
        }
        else
        {
            x1=x+31.64;y-=120;y1-=120;
        }


    }


    for(i=0;i<6;i++)
    {
        for(j=0;j<3;j++)
        {
            al_draw_filled_triangle(x,y,x,y+40,x1,y1,al_map_rgb(0,222,0));
            y+=40;y1+=40;
        }
        if(i%2==0)
        {
            x=x+31.64;x1=x-31.64;y=y-140;y1-=140;
        }
        else
        {
            x1=x+31.64;y-=120;y1-=120;
        }


    }
    x=x-3*31.64-5;y+=50;x1=x-31.64;y1=y-20;
    std:: cout <<x <<"  " <<y;
    for(i=0;i<3;i++)
    {
        for(j=0;j<3-i;j++)
        {
            if(i==0)
            {
             al_draw_filled_triangle(x,y,x,y-40,x1,y1,al_map_rgb(222,0,0));
            }
            else
            {
             al_draw_filled_triangle(x,y,x,y-40,x1,y1,al_map_rgb(222,0,0));
             al_draw_filled_triangle(x,y,x,y-40,x1+2*31.64,y1,al_map_rgb(222,0,0));
            }
            y-=40;y1-=40;
        }
        x=x1;x1=x-31.64;y=y+40*(3-i)-20;y1=y1+40*(3-i)-20;
    }
    x=296;y=200;x1=x+31.64;y1=y-20;
    for(i=0;i<3;i++)
    {
        for(j=0;j<3-i;j++)
        {
            if(i==0)
            {
             al_draw_filled_triangle(x,y,x,y-40,x1,y1,al_map_rgb(222,0,0));
            }
            else
            {
             al_draw_filled_triangle(x,y,x,y-40,x1,y1,al_map_rgb(222,0,0));
             al_draw_filled_triangle(x,y,x,y-40,x1-2*31.64,y1,al_map_rgb(222,0,0));
            }
            y-=40;y1-=40;
        }
        x=x1;x1=x+31.64;y=y+40*(3-i)-20;y1=y1+40*(3-i)-20;
    }
    al_flip_display();
    al_rest(10.0);
    al_destroy_display(display);

    return 0;
}
*/

